unit DiskEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, ImgList, Grids, ExtCtrls, StdCtrls,
  MPHexEditor, Disks;

  //FMaskedChars := [#255];  // in MPHexEditor.PAS

type
  TDiskEditor = class(TForm)
		StatusBar1: TStatusBar;
		CoolBar1: TCoolBar;
		ToolBar1: TToolBar;
		ToolButton1: TToolButton;
		ToolButton2: TToolButton;
		ImageList1: TImageList;
		ToolButton4: TToolButton;
		ToolButton5: TToolButton;
		ToolButton3: TToolButton;
		ToolButton6: TToolButton;
		ToolButton7: TToolButton;
		Editor: TMPHexEditor;
    SaveDialog1: TSaveDialog;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
		procedure ToolButton7Click(Sender: TObject);
		procedure ToolButton4Click(Sender: TObject);
		procedure ToolButton2Click(Sender: TObject);
		procedure ToolButton1Click(Sender: TObject);
		procedure ToolButton5Click(Sender: TObject);
		procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton8Click(Sender: TObject);
    procedure ToolButton9Click(Sender: TObject);
    procedure ToolButton10Click(Sender: TObject);
  public
    Disk    : TDisk;
    PartInfo: TPartInfo;
    Partition :boolean;
  	CurSec: Integer;
  	MinSec: Integer;
  	MaxSec: Integer;
    BytesPerSector: Integer;
    BytesPerCluster: Integer;
  	SecBuf: array [0..511] of Byte;
		procedure UpdateSec;
  end;

var DiskEditor: TDiskEditor;

implementation

{$R *.dfm}

uses main;

procedure TDiskEditor.ToolButton7Click(Sender: TObject);
var M           : TMemoryStream;
begin
  if SaveDialog1.Execute then
  begin
    M := TMemoryStream.Create;
    Disk.Position := Int64(CurSec) * BytesPerSector;
    M.CopyFrom(Disk,BytesPerSector);
    M.SaveToFile(SaveDialog1.FileName);
    M.Free;
  end;
end;

procedure TDiskEditor.UpdateSec;
var M           : TMemoryStream;
    bytesPerSec : Int64;
begin
  M := TMemoryStream.Create;

  Disk.Position := Int64(CurSec) * Int64(BytesPerSector);
  M.CopyFrom(Disk,BytesPerSector);
  Editor.LoadFromStream(M);
  M.Free;

  bytesPerSec := Disk.Size div Disk.TotalSectors;
  StatusBar1.Panels[0].Text := 'DiskSect: ' + IntToStr( CurSec ) +
                               ' ('         + IntToStr( CurSec*bytesPerSec ) + ')';
  							               //' (0x'     + IntToHex(CurSec,8) + ')';
  StatusBar1.Panels[1].Text := 'PartSect: ' + IntToStr( CurSec - MinSec ) +
                               ' ('         + IntToStr((CurSec - MinSec )*bytesPerSec) + ')';
                               //' (0x'     + IntToHex(CurSec - MinSec,8) + ')';
  StatusBar1.Panels[2].Text := 'Cluster: '  +
    IntToStr(Round(         ((CurSec - MinSec)*bytesPerSec)/BytesPerCluster          ));
    //IntToStr(Round(         (CurSec - MinSec)*bytesPerSec/BytesPerCluster          ));
  StatusBar1.Panels[3].Text := 'Position: ' + IntToStr(Round(((CurSec - MinSec) / (MaxSec - MinSec)) * 100)) + ' %';
  StatusBar1.Panels[0].Width:= StatusBar1.Canvas.TextWidth(StatusBar1.Panels[0].text)+50;
  StatusBar1.Panels[1].Width:= StatusBar1.Canvas.TextWidth(StatusBar1.Panels[0].text)+50;
  StatusBar1.Panels[2].Width:= StatusBar1.Canvas.TextWidth(StatusBar1.Panels[0].text)+50;
  StatusBar1.Panels[3].Width:= StatusBar1.Canvas.TextWidth(StatusBar1.Panels[0].text)+50;
end;

procedure TDiskEditor.ToolButton8Click(Sender: TObject);
var S: string;
    bytesPerSec : Int64;
begin
  if InputQuery('Go to Byte Position','Byte Offset:', S) then
  begin
    bytesPerSec := Disk.Size div Disk.TotalSectors;
    CurSec := MinSec + Trunc((StrToInt64(S) / bytesPerSec));
   UpdateSec;
  end;
end;

procedure TDiskEditor.ToolButton4Click(Sender: TObject);
var S: string;
begin
  if InputQuery('Go to sector','Logical sector number:',S) then
  begin
    CurSec := MinSec + StrToInt64(S);
    UpdateSec;
  end;
end;

procedure TDiskEditor.ToolButton2Click(Sender: TObject);
begin
  if CurSec < MaxSec then
    Inc(CurSec);
  UpdateSec;
end;

procedure TDiskEditor.ToolButton9Click(Sender: TObject);
begin
  if editor.BytesPerRow>4 then
     editor.BytesPerRow := editor.BytesPerRow div 2;
  editor.Refresh;
end;

procedure TDiskEditor.ToolButton10Click(Sender: TObject);
begin
  if editor.BytesPerRow<128 then
     editor.BytesPerRow := editor.BytesPerRow * 2;
  editor.Refresh;
end;

procedure TDiskEditor.ToolButton1Click(Sender: TObject);
begin
  if CurSec > MinSec then
    Dec(CurSec);
  UpdateSec;
end;

procedure TDiskEditor.ToolButton5Click(Sender: TObject);
begin
  CurSec := MinSec;
  UpdateSec;
end;

procedure TDiskEditor.ToolButton3Click(Sender: TObject);
begin
  CurSec := MaxSec;
  UpdateSec;
end;

end.

