{*******************************************************************************
Application-level (read only) Ext2 filesytem driver v0.1
            by Miika Sivola (smiika@mbnet.fi)

references
http://www.nongnu.org/ext2-doc/ext2.html
*******************************************************************************}
unit Ext2;

interface

uses Main,Disks,dialogs,SysUtils;

type

  TSuperBlock = packed record
    s_inodes_count: Cardinal;
    s_blocks_count: Cardinal;
    s_r_blocks_count: Cardinal;
    s_free_blocks_count: Cardinal;
    s_free_inodes_count: Cardinal;
    s_first_data_block: Cardinal;
    s_log_block_size: Cardinal;
    s_log_frag_size: Cardinal;
    s_blocks_per_group: Cardinal;
    s_frags_per_group: Cardinal;
    s_inodes_per_group: Cardinal;
    s_mtime: Cardinal;
    s_wtime: Cardinal;
    s_mnt_count: Word;
    s_max_mnt_count: Word;
    s_magic: Word;
    s_state: Word;
    s_errors: Word;
    s_minor_rev_level: Word;
    s_lastcheck: Cardinal;
    s_checkinterval: Cardinal;
    s_creator_os: Cardinal;
    s_rev_level: Cardinal;
    s_def_resuid: Word;
    s_def_resgid: Word;
    //-- EXT2_DYNAMIC_REV Specific --
    s_first_ino: Cardinal;
    s_inode_size: Word;
    s_block_group_nr: Word;
    s_feature_compat: Cardinal;
    s_feature_incompat: Cardinal;
    s_feature_ro_compat: Cardinal;
    s_uuid: array [0..15] of Byte;
    s_volume_name: array [0..15] of ansichar;
    s_last_mounted: array [0..63] of Byte;
    s_algo_bitmap: Cardinal;
  end;


  TGroupDescriptor = packed record
     bg_block_bitmap: Cardinal;
     bg_inode_bitmap: Cardinal;
     bg_inode_table: Cardinal;
     bg_free_blocks_count: Word;
     bg_free_inodes_count: Word;
     bg_used_dirs_count: Word;
     bg_pad: Word;
     bg_reserved: array [0..11] of Byte;
     end;

  TExt2 = class
    constructor Create(APartInfo: TPartInfo);
    destructor Destroy; override;
  public
    Disk: TDisk;
    PathInfo:   TPartInfo;
    SuperBlock: TSuperBlock;
    end;

implementation

{ TExt2 }

constructor TExt2.Create(APartInfo: TPartInfo);
var
Buf: array [0..511] of Byte;
GD: TGroupDescriptor;
begin
PathInfo := APartInfo;
Disk := PathInfo.Disk;
//superblock is always located at 1024th byte
Disk.Position := Int64(PathInfo.StartSec * Int64(512) + 1024);
Disk.Read(Buf,512);
Move(Buf,SuperBlock,SizeOf(SuperBlock));
//correct?
Disk.Position := Int64(PathInfo.StartSec * Int64(512) + ((SuperBlock.s_log_block_size * SuperBlock.s_log_frag_size) * 2) * 512);
Disk.Read(Buf,512);
Move(Buf,GD,SizeOf(GD));
ShowMessage(inttostr(GD.bg_inode_table ));
end;

destructor TExt2.Destroy;
begin
  inherited Destroy;
end;

end.

