unit FAT32FileProps;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, FAT32Browse, Main, FAT32, Util;

type

  TFAT32FilePropsForm = class(TForm)
    GroupBox1: TGroupBox;
    DirEntList: TListView;
    Button1: TButton;
    procedure AddDEInfo(Name,Value: string);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  public
    FAT32: TFAT32;
    DirEnt: TFAT32DirEntry;
  end;

var
  FAT32FilePropsForm: TFAT32FilePropsForm;

implementation

{$R *.dfm}

procedure TFAT32FilePropsForm.AddDEInfo(Name, Value: string);
var
I: TListItem;
begin
I := DirEntList.Items.Add;
I.Caption := Name;
I.SubItems.Add(Value);
end;

{procedure TFAT32FilePropsForm.AddCLInfo(Num,Clust,Sec,Util: Cardinal);
var
I: TListItem;
begin
I := ClustList.Items.Add;
I.Caption := IntToStr(Num);
I.SubItems.Add(IntToStr(Clust));
I.SubItems.Add(IntToStr(Sec));
if aDirectory in DirEnt.Attributes then
I.SubItems.Add('-')
else
I.SubItems.Add(IntToStr(Util) + ' %');
end;}

procedure TFAT32FilePropsForm.Button1Click(Sender: TObject);
begin
Close;
end;

procedure TFAT32FilePropsForm.FormShow(Sender: TObject);
begin
AddDEInfo('DOS Name',DirEnt.FileName);
AddDEInfo('DOS Extension',DirEnt.FileExt);
AddDEInfo('Attributes',FAT32AttribsToStr(DirEnt.Attributes));
AddDEInfo('NT byte',IntToHex(DirEnt.NT,2) + ' (hex)');
AddDEInfo('Tenth of creation second',IntToStr(DirEnt.TenthOfCrtSec));
AddDEInfo('Time created',FAT32TimeToStr(DirEnt.TimeCreated));
AddDEInfo('Date created',FAT32DateToStr(DirEnt.DateCreated));
AddDEInfo('Date last accessd',FAT32DateToStr(DirEnt.DateAccessed));
AddDEInfo('First cluster',IntToStr(DirEnt.StartClust or (DirEnt.StartClustHigh shl 16)));
AddDEInfo('Time last modified',FAT32TimeToStr(DirEnt.Time));
AddDEInfo('Date last modified',FAT32DateToStr(DirEnt.Date));
AddDEInfo('Size',IntToSize(DirEnt.Size) + ' (' + IntToStr(DirEnt.Size) + ' bytes)');

{ClustNum := FAT32FileBeginClust(DirEnt);
ClustCount := 1;
if FAT32.FatType = ftFAT32 then
 repeat
 if DirEnt.Size > FAT32.BootSec.SecPerClust * FAT32.BootSec.BytesPerSec * ClustCount then
 AddCLInfo(ClustCount,ClustNum,FAT32.DataStartSec + (ClustNum * FAT32.BootSec.SecPerClust) - (2 * FAT32.BootSec.SecPerClust),100)
 else
 AddCLInfo(ClustCount,ClustNum,FAT32.DataStartSec + (ClustNum * FAT32.BootSec.SecPerClust) - (2 * FAT32.BootSec.SecPerClust),((DirEnt.Size mod (FAT32.BootSec.SecPerClust * FAT32.BootSec.BytesPerSec)) * 100) div (FAT32.BootSec.SecPerClust * FAT32.BootSec.BytesPerSec));
 Inc(ClustCount);
 ClustNum := FAT32.NextCluster(ClustNum);
 until (ClustNum >= $0FFFFFF8) or (ClustNum < 2)
else
 repeat
 if DirEnt.Size > FAT32.BootSec.SecPerClust * FAT32.BootSec.BytesPerSec * ClustCount then
 AddCLInfo(ClustCount,ClustNum,FAT32.DataStartSec + (ClustNum * FAT32.BootSec.SecPerClust) - (2 * FAT32.BootSec.SecPerClust),100)
 else
 AddCLInfo(ClustCount,ClustNum,FAT32.DataStartSec + (ClustNum * FAT32.BootSec.SecPerClust) - (2 * FAT32.BootSec.SecPerClust),((DirEnt.Size mod (FAT32.BootSec.SecPerClust * FAT32.BootSec.BytesPerSec)) * 100) div (FAT32.BootSec.SecPerClust * FAT32.BootSec.BytesPerSec));
 Inc(ClustCount);
 ClustNum := FAT32.NextCluster(ClustNum);
 until (ClustNum >= $FFF8) or (ClustNum < 2);
if ClustNum < 2 then
ClustList.Items.Add.Caption := 'Error: unterminated cluster chain';}
end;

end.
