unit FAT32Props;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Disks, Main, FAT32;

type
  TFAT32PropsForm = class(TForm)
    Button1: TButton;
    GroupBox1: TGroupBox;
    BootSecList: TListView;
    GroupBox2: TGroupBox;
    FSSecList: TListView;
    procedure AddBSInfo(Name,Value: string);
    procedure AddFSInfo(Name, Value: string);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
  public
    FAT32: TFAT32;
  end;

var
  FAT32PropsForm: TFAT32PropsForm;

implementation

{$R *.dfm}

procedure TFAT32PropsForm.AddBSInfo(Name, Value: string);
var
I: TListItem;
begin
I := BootSecList.Items.Add;
I.Caption := Name;
I.SubItems.Add(Value);
end;

procedure TFAT32PropsForm.AddFSInfo(Name, Value: string);
var
I: TListItem;
begin
I := FSSecList.Items.Add;
I.Caption := Name;
I.SubItems.Add(Value);
end;

procedure TFAT32PropsForm.FormShow(Sender: TObject);
const
YesNo: array [0..1] of string = ('Yes','No');
var
BootSec: TFAT32BootRecord;
InfoSec: TFAT32FileSystemInfo;
begin
BootSec := FAT32.BootSec;
InfoSec := FAT32.InfoSec;
AddBSInfo('OEM Name',BootSec.OemName);
AddBSInfo('Bytes per sector',IntToStr(BootSec.BytesPerSec));
AddBSInfo('Sectors per cluster',IntToStr(BootSec.SecPerClust));
AddBSInfo('Reserved sectors',IntToStr(BootSec.ReservedSectors));
AddBSInfo('Number of FAT copies',IntToStr(BootSec.NumOfFatCopies));
AddBSInfo('Max root entries (old)',IntToStr(BootSec.MaxRootEntries));
AddBSInfo('Sectors in partition (old)',IntToStr(BootSec.SectorsOld));
AddBSInfo('Media descriptor',IntToHex(BootSec.MediaDescriptor,2) + ' (hex)');
AddBSInfo('Sectors per FAT (old)',IntToHex(BootSec.MediaDescriptor,2) + ' (hex)');
AddBSInfo('Sectors per track',IntToStr(BootSec.SectorsPerTrack));
AddBSInfo('Numbers of heads',IntToStr(BootSec.NumOfHeads));
AddBSInfo('Hidden sectors',IntToStr(BootSec.HiddenSectors));
AddBSInfo('Sectors in partition',IntToStr(BootSec.SectorsSize));
AddBSInfo('Sectors per FAT',IntToStr(BootSec.SectorsPerFat));
AddBSInfo('Flags',IntToHex(BootSec.Flags,4) + ' (hex)');
AddBSInfo('FAT Mirroring enabled',YesNo[(BootSec.Flags shr 7) and 1]);
AddBSInfo('Version',IntToStr(BootSec.Version shl 8) + '.' + IntToStr(BootSec.Version and $FF));
AddBSInfo('Root directory cluster',IntToStr(BootSec.RootDirStartClust));
AddBSInfo('Filesystem info sector',IntToStr(BootSec.FileSystemInfoSec));
AddBSInfo('Bootsector''s backup',IntToStr(BootSec.BackupSec));
AddBSInfo('Drive number',IntToStr(BootSec.DriveNumber));
AddBSInfo('Extra signature',IntToHex(BootSec.ExtraSignature,4) + ' (hex)');
AddBSInfo('Serial number',IntToStr(BootSec.SerialNumber));
AddBSInfo('Volume name',BootSec.VolumeName);
AddBSInfo('FAT name',BootSec.FATName);
AddBSInfo('Boot signature',IntToHex(BootSec.BootSignature,4) + ' (hex)');

AddFSInfo('Leading Signature',IntToHex(InfoSec.Signature,8) + ' (hex)');
AddFSInfo('FS Info Signature',IntToHex(InfoSec.FSInfoSignature,8) + ' (hex)');
AddFSInfo('Free Clusters',IntToStr(InfoSec.FreeClusters));
AddFSInfo('Most recent cluster',IntToStr(InfoSec.RecentlyAllocatedClust));
AddFSInfo('Boot signature',IntToHex(InfoSec.BootSignature,4) + ' (hex)');
end;

procedure TFAT32PropsForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
FAT32.Free;
Release;
end;

procedure TFAT32PropsForm.Button1Click(Sender: TObject);
begin
Close;
end;

end.
