unit Main;

// diskbuddy k 109352 110067 119
// diskbuddy m 116850
// diskbuddy m 33398
// diskbuddy m 118045 M:\ctupdate\client\wsus\wsusscn2.cab
// diskbuddy y 0

// diskbuddy f 9 90062 78768 297624
// diskbuddy h 25
// diskbuddy h 11774
// - attrlist - name - reference to MFT #
// if (done.IndexOf(inttostr(mftno))<0) then

interface

uses
  Windows, Messages, SysUtils, StrUtils, Variants, Classes,
  Graphics, Controls, Forms, Dialogs, Menus, ComCtrls,
  StdCtrls, ImgList, ExtCtrls, VirtualTrees,
  About, Disks, DiskName, BetterProgressBar,
  Util;

const sVersionInfo = 'DiskBuddy v0.8 - 22. Dec 2016';

// forward-declarations
procedure SysErrMsg(ErrCode: Integer; S: string);
function CalcAlignedValueUp(value, aligned: int64):int64;
function Align8(Value: Cardinal): Cardinal;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;

    DiskTree: TTreeView;
    DiskList: TListView;

    SaveDlg: TSaveDialog;
    Memo1: TMemo;
    leftDriveLetters: TMemo;

    StatusBar1: TStatusBar;
    Splitter2: TSplitter;
    Splitter3: TSplitter;

    ImageList_Big: TImageList;
    ImageList_Small: TImageList;
    im: TImage;

    ToggleDriveview1: TMenuItem;
    File1: TMenuItem;
    Exit1: TMenuItem;
    About1: TMenuItem;
    pMenu: TPopupMenu;
    DiskEditor2: TMenuItem;
    FileBrowser1: TMenuItem;
    Info1: TMenuItem;
    MFTEntryViewer1: TMenuItem;
    SearchDeletedFiles1: TMenuItem;
    ViewAttributeDefinations1: TMenuItem;
    SaveSystemSectors1: TMenuItem;
    DumpToFile: TMenuItem;
    RefreshDrivelist1: TMenuItem;
    ToggleIcons: TMenuItem;
    Actions1: TMenuItem;
    PartitionDetails1: TMenuItem;
    ExpandAll1: TMenuItem;
    CollapseAll1: TMenuItem;
    ExpandAll2: TMenuItem;
    CollapseAll2: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;

    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure DiskTreeOldMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure DiskTreeOldDblClick(Sender: TObject);
    procedure DiskTreeOldChange(Sender: TObject; Node: TTreeNode);
    procedure DiskListChange(Sender: TObject; Item: TListItem; Change: TItemChange);
    procedure DiskListDblClick(Sender: TObject);

    procedure ExpandAll1Click(Sender: TObject);
    procedure CollapseAll1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Splitter1Moved(Sender: TObject);
    procedure Splitter2Moved(Sender: TObject);
    procedure pMenuPopup(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure SearchDeletedFiles1Click(Sender: TObject);
    procedure DiskEditor2Click(Sender: TObject);
    procedure FileBrowser1Click(Sender: TObject);

    procedure InfoDrive(Sender:TObject; s:string; data:PPartinfo);
    procedure SearchDeletedFiles(Sender:TObject; s:string; data:PPartinfo);
    procedure DiskEditor(Sender: TObject; s: string; data:Pointer);
    procedure BrowseFiles(Sender:TObject; s:string; data:PPartinfo);
    procedure MFTEntryViewer1Click(Sender: TObject);
    procedure ViewAttributeDefinations(Sender: TObject; s:string; data:PPartinfo);

    procedure ViewAttributeDefinations1Click(Sender: TObject);
    procedure SaveSystemSectors1Click(Sender: TObject);
    procedure DumpToFileClick(Sender: TObject);
    procedure ToggleIconsClick(Sender: TObject);
    procedure ToggleDriveview1Click(Sender: TObject);
    procedure PartitionDetails1Click(Sender: TObject);

    procedure RefreshMenuItems(Sender: TObject);
    procedure RefreshDrivelist1Click(Sender: TObject);

    procedure imMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure VerticalTextAt(x,y: integer; const s: string);
    procedure CheckTree(pt: Tpoint);
    function  ChecKTreeItem(pt:TPoint; p: pPartInfo; name: string; extended: Boolean;noDisks: Integer; first, last:boolean): Boolean;
    procedure DiskTreeKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
   { Private declarations }
    procedure ClearGraph;
    procedure RedrawPartitions;

    procedure BoldTreeNode(treeNode: TTreeNode);
    procedure UpdateMemo(s: string; partinfo:PPartinfo);

    function DiskTreeAddItem(parent:TTreeNode; s:string; ImageIndex:integer; partinfo: pPartInfo):TTreeNode;
    procedure DiskListAddItem(s: string; ImageIndex: integer; partinfo: pPartInfo);

    procedure DrawPartition(p: pPartInfo; name: string; extended: Boolean; noDisks: Integer; first, last:boolean);
    procedure DrawPartitionTables;

    function GetNonPhysicalDriveLetters(parent: TTreeNode):string;
    function GetDriveLetter(p: TPartInfo; StartSector:int64):string;

    procedure FillLeftDriveLetters;

    function ScanForPartitions(Disk: TDisk; bytesPerSec: Integer; localStartSect: Int64; extendedPart:Boolean; physpart:byte; var Parent: TTreeNode):byte;
    procedure ScanDisksForPartitions;
  public
   { Public declarations }
  end;

var MainForm   : TMainForm;
    logfile    : TFileStream;
    ShadowMode : integer;
    diskcount  : integer;
    ini_file   : string;


implementation

uses Ext2, DiskProp, DiskEdit,
     NTFS, NTFSMFT, NTFSBrowse, NTFSSearch, NTFSProps, NTFSAttrDef,
     FAT32, FAT32Props, FAT32Browse, FAT32Search;

{$R *.dfm}

///////////////////////////////////////////////
procedure TMainForm.FormCreate(Sender: TObject);
var i, j, W, H, L, T: integer;
    MFTid:cardinal;
    s: string;
    inistr: array [0..259] of char;
begin
  ini_file:=ExpandFileName(paramstr(0));
  ini_file:=ExtractFilePath(ini_file) + ChangeFileExt(ExtractFileName(ParamStr(0)), '.ini');
  Caption := main.sVersionInfo; // 'DiskBuddy 0.8';

  L:=Left; T:=Top; W:=width; H:=Height;
  L:=integer(GetPrivateProfileInt('DiskBuddy','ScreenX',L,PChar(ini_file)));
  T:=integer(GetPrivateProfileInt('DiskBuddy','ScreenY',T,PChar(ini_file)));
  W:=integer(GetPrivateProfileInt('DiskBuddy','ScreenW',W,PChar(ini_file)));
  H:=integer(GetPrivateProfileInt('DiskBuddy','ScreenH',H,PChar(ini_file)));
  SetBounds(L, T, W, H);
  W:=im.Width;
  panel3.Width:=GetPrivateProfileInt('DiskBuddy','DiskmapWidth',W,PChar(ini_file));

  DoubleBuffered:=TRUE;
  ShadowMode:=2;

  i := GetPrivateProfileString('DiskBuddy','IconSize', 'Small',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, i);
  if s='Small' then begin
    disktree.Images:=ImageList_small;
    disktree.Indent:=19;
    diskList.SmallImages:=ImageList_Small;
    diskList.ViewStyle:=vsReport;
    diskList.Font.Size:=8;
    disktree.Font.Size:=8;
    diskList.Font.Style:=[];
    disktree.Font.Style:=[];
  end else begin
    disktree.Images:=ImageList_big;
    disktree.Indent:=35;
    diskList.SmallImages:=ImageList_big;
    diskList.ViewStyle:=vsReport;
    diskList.Font.Size:=12;
    disktree.Font.Size:=12;
    diskList.Font.Style:=[fsbold];
    disktree.Font.Style:=[fsbold];
  end;

  i := GetPrivateProfileString('DiskBuddy','DiskListVisible', 'FALSE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, i);
  if s='TRUE' then
    ToggleDriveview1Click(sender);

  Show;

  if s='TRUE' then
    DiskList.SetFocus
  else
    DiskTree.SetFocus;
  Application.ProcessMessages;

  RefreshDrivelist1Click(Sender);
  Application.ProcessMessages;
  DiskTree.Repaint;
  DiskList.Repaint;
  DiskTree.Refresh;
  DiskList.Refresh;

  if paramstr(1)<>'' then
  for i:=0 to DiskTree.Items.Count-1 do
  begin
    if (uppercase(paramstr(1)[1]) = uppercase(DiskTree.Items[i].Text[1])) and
       (DiskTree.Items[i].Text[2]=':') then
    begin
      DiskTree.Items[i].Selected:=true;
      if (pos('NTFS',DiskTree.Selected.Text)=5) then
      for j:=2 to ParamCount do
      begin
        MFTid:=StrToIntDef(ParamStr(j),-1);
        if (MFTid<>-1) then
        begin
          with TNTFSMFTForm.Create(Application) do
          begin
            PartName:=IntToStr(DiskTree.Selected.Index); //  DiskTree.Selected.Text;
            NTFS:=TNTFS.Create(pPartInfo(DiskTree.Selected.Data)^);
            NTFS.partname:=DiskTree.Selected.Text;
            CurMFT:=MFTid;
            left:=left+(j-2)*20;
            top :=top +(j-2)*20;
            //Show;
            UpdateNew;
          end;
        end;
      end;
    end;
  end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  WritePrivateProfileString('DiskBuddy','ScreenX', PChar(IntToStr(MainForm.Left  )), PChar(ini_file));
  WritePrivateProfileString('DiskBuddy','ScreenY', PChar(IntToStr(MainForm.Top   )), PChar(ini_file));
  WritePrivateProfileString('DiskBuddy','ScreenW', PChar(IntToStr(MainForm.Width )), PChar(ini_file));
  WritePrivateProfileString('DiskBuddy','ScreenH', PChar(IntToStr(MainForm.Height)), PChar(ini_file));
  WritePrivateProfileString('DiskBuddy','DiskmapWidth', PChar(IntToStr(panel3.Width)), PChar(ini_file));
  if disktree.Images=ImageList_Big then
  WritePrivateProfileString('DiskBuddy','IconSize', PChar('Big'), PChar(ini_file))
  else
  WritePrivateProfileString('DiskBuddy','IconSize', PChar('Small'), PChar(ini_file));

  if DiskList.Visible then
  WritePrivateProfileString('DiskBuddy','DiskListVisible', PChar('TRUE'), PChar(ini_file))
  else
  WritePrivateProfileString('DiskBuddy','DiskListVisible', PChar('FALSE'), PChar(ini_file));

end;

procedure TMainForm.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
    if (Key=88) or (key=120) then
    begin
      if ((ssAlt in shift) OR (ssCtrl in shift)) then // strg/alt+x
        Close;
    end;
    if key=VK_F5 then
    begin
      RefreshDrivelist1Click(sender);
    end;
end;


procedure TMainForm.BoldTreeNode(treeNode: TTreeNode);
var treeItem: TTVItemStateEx; //  TTVItem;
begin
(**-)
    if not Assigned(treeNode) then Exit;

    with treeItem do
    begin
      hItem := treeNode.ItemId;
      stateMask := TVIS_BOLD;
      mask := TVIF_HANDLE or TVIF_STATE;
      state := TVIS_BOLD
    end;
    TreeView_SetItem(treeNode.Handle, treeItem);
(**)
end;

function TMainForm.DiskTreeAddItem(parent:TTreeNode; s:string; ImageIndex:integer; partinfo: pPartInfo):TTreeNode;
var Node    : TTreeNode;
begin
  Node := DiskTree.Items.AddChild(Parent, s);
  Node.ImageIndex := imageindex;
  Node.SelectedIndex := imageindex;
  Node.Data := PartInfo;
  if (node.Level=0) then
  begin
    BoldTreeNode(Node);
  end;
  DiskTree.FullExpand;
  DiskTree.Refresh;
  result:=Node;
end;

procedure TMainForm.DiskTreeKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_RETURN) then
  begin
      Application.ProcessMessages;
      ClearMessageBuffers;
      DiskTreeOldDblClick(Sender);
      Application.ProcessMessages;
      ClearMessageBuffers;
  end;
end;

procedure TMainForm.DiskListAddItem(s: string; ImageIndex: integer; partinfo: pPartInfo);
var I: TListItem;
begin
  I := DiskList.Items.Add;
  I.Caption := s;
  I.ImageIndex:=ImageIndex;
  I.Data:=partinfo;
  DiskList.Refresh;
end;


procedure TMainForm.PartitionDetails1Click(Sender: TObject);
begin
  PartitionDetails1.Checked:=not PartitionDetails1.Checked;
  RefreshDrivelist1Click(sender);
end;

procedure TMainForm.ToggleDriveview1Click(Sender: TObject);
begin
  if DiskTree.Visible then begin
    DiskTree.Align:=alNone;
    DiskList.Align:=alClient;
  end else begin
    DiskList.Align:=alNone;
    DiskTree.Align:=alClient;
  end;
  DiskTree.Visible:=not DiskTree.Visible;
  DiskList.Visible:=not DiskList.Visible;
  if DiskTree.Visible then DiskTree.SetFocus else DiskList.SetFocus;
end;

procedure TMainForm.ToggleIconsClick(Sender: TObject);
begin
  if disktree.Images=ImageList_big then
  begin
    disktree.Images:=ImageList_small;
    disktree.Indent:=19;
    diskList.SmallImages:=ImageList_Small;
    diskList.ViewStyle:=vsReport;
    disktree.Font.Size:=disktree.Font.Size-4;
    diskList.Font.Size:=disktree.Font.Size-4;
    diskList.Font.Style:=[];
    disktree.Font.Style:=[];
  end else begin
    disktree.Images:=ImageList_big;
    disktree.Indent:=35;
    diskList.SmallImages:=ImageList_big;
    diskList.ViewStyle:=vsReport;
    disktree.Font.Size:=disktree.Font.Size+4;
    diskList.Font.Size:=disktree.Font.Size+4;
    diskList.Font.Style:=[fsbold];
    disktree.Font.Style:=[fsbold];
  end;
end;

/////////////////////////////////////////////////////////

procedure SysErrMsg(ErrCode: Integer; S: string);
var Len: Integer;
    Buffer: array[0..255] of char;
begin
  if ErrCode=0 then exit;
  Len := FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM or
      FORMAT_MESSAGE_ARGUMENT_ARRAY, nil, ErrCode, 0, Buffer,
      SizeOf(Buffer), nil);
  while (Len > 0) and (Buffer[Len - 1] in [#0..#32, '.']) do Dec(Len);
  //Application.MessageBox(PChar(S + IntToStr(ErrCode) + Chr(13) + Buffer), 'error');
  MainForm.memo1.Lines.Add(S + IntToStr(ErrCode) + Chr(13) + Buffer);
  MainForm.memo1.ScrollBy(0,20);
end;

function CalcAlignedValueUp(value, aligned:int64):int64;
begin
  result:= (   ( trunc((value - (value mod aligned))   /   aligned)+1)*aligned    );
end;

function Align8(Value: Cardinal): Cardinal;
begin
  if Value mod 8 <> 0 then
    Result := Value + (8 - (Value mod 8))
  else
    Result := Value;
end;

////////////////////////////////////////////////////////////

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
  with TAboutForm.Create(nil) do
  begin
    ShowModal;
    Free;
  end;
end;

procedure TMainForm.RefreshMenuItems(Sender: TObject);
var i:integer;
begin
  for I := 0 to pMenu.Items.Count - 1 do
    pMenu.Items[I].Enabled := False;

  if (DiskTree.Visible) and (DiskTree.Selected <> nil) then
  begin
    DiskEditor2.Enabled := True;
    Info1.Enabled := True;
    SaveSystemSectors1.Enabled:=True;
    if Pos('NTFS',DiskTree.Selected.Text) > 0 then
    begin
      FileBrowser1.Enabled := True;
      MFTEntryViewer1.Enabled := True;
      SearchDeletedFiles1.Enabled := True;
      ViewAttributeDefinations1.Enabled := True;
    end;
    if Pos('FAT',DiskTree.Selected.Text) > 0 then
    begin
      FileBrowser1.Enabled := True;
      SearchDeletedFiles1.Enabled := True;
    end;
  end else if (DiskList.Visible) and (DiskList.Selected <> nil) then
  begin
    DiskEditor2.Enabled := True;
    Info1.Enabled := True;
    SaveSystemSectors1.Enabled:=True;
    if Pos('NTFS',DiskList.Selected.Caption) > 0 then
    begin
      FileBrowser1.Enabled := True;
      MFTEntryViewer1.Enabled := True;
      SearchDeletedFiles1.Enabled := True;
      ViewAttributeDefinations1.Enabled := True;
    end;
    if Pos('FAT',DiskList.Selected.Caption) > 0 then
    begin
      FileBrowser1.Enabled := True;
      SearchDeletedFiles1.Enabled := True;
    end;
  end;
  pMenu.Items[pMenu.Items.Count-1].Enabled:=True;

  if DiskTree.Visible then begin
  ExpandAll2.Enabled:=true;
  CollapseAll2.Enabled:=true;
  end else begin
  ExpandAll2.Enabled:=false;
  CollapseAll2.Enabled:=false;
  end;

  for I := 0 to pMenu.Items.Count - 1 do
    MainMenu1.Items[1].Items[i].Enabled:=pMenu.Items[I].Enabled;
end;

procedure TMainForm.pMenuPopup(Sender: TObject);
begin
  RefreshMenuItems(Sender);
end;

procedure TMainForm.DiskTreeOldMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  DiskTree.Selected :=  DiskTree.GetNodeAt(X,Y);
end;

procedure TMainForm.DiskTreeOldDblClick(Sender: TObject);
begin
if DiskTree.Selected=nil then exit;
if DiskTree.Selected.ImageIndex = 1 then
FileBrowser1.Click;
end;

procedure TMainForm.DiskListDblClick(Sender: TObject);
begin
if DiskList.Selected=nil then exit;
if DiskList.Selected.ImageIndex = 1 then
FileBrowser1.Click;
end;

procedure TMainForm.RedrawPartitions;
begin
  if (DiskTree.TopItem=nil) or (not visible) then exit;
  im.Picture.Bitmap.Width:=im.Width;
  im.Picture.Bitmap.Height:=im.Height;
  DrawPartitionTables;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  RedrawPartitions;
end;

procedure TMainForm.Splitter1Moved(Sender: TObject);
begin
  RedrawPartitions;
end;

procedure TMainForm.Splitter2Moved(Sender: TObject);
begin
  RedrawPartitions;
end;

procedure TMainForm.ExpandAll1Click(Sender: TObject);
begin
  DiskTree.FullExpand;
end;

procedure TMainForm.CollapseAll1Click(Sender: TObject);
begin
  DiskTree.FullCollapse;
end;

////////////////////////////////////////////////////////////////////////////

function GetHDDSerial(drivestr:string):string;
var id, dwx,dwy : Dword;
begin
  if GetVolumeInformation(pchar(drivestr),nil,0,@id,dwx,dwy,nil,0) then
  begin
		result:=Format('%02X%02X-%02X%02X',
				[HIBYTE(id shr    16), LOBYTE(id shr    16),
				 HIBYTE(id and $FFFF), LOBYTE(id and $FFFF)]);
  end
  else
    result:='ERROR';
end;

procedure TMainForm.UpdateMemo(s: string; partinfo:PPartinfo);
var fa, ts : Int64;
    tf: TLargeInteger;
    s1, ssub0, ssub, ssize:string;
begin
    ssub0:='';
    ssub:='';
    if partinfo.Disk<>nil then
    begin
      if partinfo.Disk.Physical then
      begin
        if partinfo.partno=0 then
        begin
          ssub0:='(hd'+inttostr(partinfo.Disk.Number)+')';
          s:=s+' serial: '+partinfo.Disk.DiskSerial;
          ssize:='        Size: ' +IntToDottetInt(partinfo.Disk.Size)+' byte';
        end else begin
          ssub0:='(hd'+inttostr(partinfo.Disk.Number)+','+
                       inttostr(partinfo.partno)+')';
          ssize:='        Size: ' +IntToDottetInt(partinfo.SizeSec*partinfo.Disk.DiskGeometry.BytesPerSector)+' byte';
        end;
      end else begin
        ssub0:='nonphysical Disk'+inttostr(partinfo.Disk.Number);
      end;
    end;

    if partinfo.sLetter<>'' then
    begin
        ssub:=' ' + partinfo.sLetter+':\ ['+
                    partinfo.sFSName+'] "'+
                    partinfo.sVolName+'" ';
        if partinfo.partno=0 then
        ssub:=ssub+partinfo.Disk.DiskSerial;
        tf:=0;
        GetDiskFreeSpaceEx(PChar(LeftStr(s, 2)+'\'), fa, ts, @tf);
        ssub:=ssub + IntToSize(ts) + ' | '+IntToSize(fa)+' free - serial: ' + partinfo.sVolSerial; //GetHDDSerial(partinfo.sLetter+':\');
    end else begin
        ssub:=' ' + trim(s);
    end;

    memo1.Text:=ssub0 + ssub + Chr(13)+Chr(10);
    memo1.Text:=memo1.Text +
    'StartSector  : '+IntToDottetInt(PartInfo.StartSec) +
    Chr(13)+Chr(10)+
    'EndSector    : '+IntToDottetInt(PartInfo.StartSec+PartInfo.SizeSec-1) +
    Chr(13)+Chr(10)+
    'TotalSectors : '+IntToDottetInt(PartInfo.SizeSec) +
    ssize;
end;

procedure TMainForm.DiskListChange(Sender: TObject; Item: TListItem;Change: TItemChange);
begin
    if Item.Data=nil then exit;
    RefreshMenuItems(Sender);
    UpdateMemo(Item.Caption, pPartInfo(Item.Data));
end;

procedure TMainForm.DiskTreeOldChange(Sender: TObject; Node: TTreeNode);
begin
    Application.ProcessMessages;
    if (node=nil) or (diskcount=0) then exit;
    if Node.Data=nil then exit;
    RefreshMenuItems(Sender);
    UpdateMemo(node.text, pPartInfo(Node.Data));
end;

procedure TMainForm.SaveSystemSectors1Click(Sender: TObject);
var M       : TMemoryStream;
    Disk    : TDisk;
    Part    : PPartInfo;
    MinSec: integer;
    FATBoot : TFAT32BootRecord;
    Path,
    diskname,
    partname:string;
begin

 if DiskTree.Selected.Parent <> nil then
 begin

 SaveDlg.FileName := '(no name)';
 if SaveDlg.Execute then
   Path := ExtractFilePath(SaveDlg.FileName)
 else exit;
 if path[length(path)]<>'\' then path:=path+'\';

 Part := pPartInfo(DiskTree.Selected.Data);
 Disk := Part.Disk;

 diskname:='hd'+inttostr(Disk.Number);
 partname:=','+inttostr(DiskTree.Selected.index)+'_';

 Disk.Position := 0;
 StatusBar1.Panels[0].Text:='Saving Master Boot Record...';
 StatusBar1.Refresh;
 M:=TMemoryStream.Create;
 if (Disk.DiskHandle=0) OR (Disk.DiskHandle=INVALID_HANDLE_VALUE) then
   if Disk.Physical then
   Disk.OpenVolumePhysical
   else
   Disk.OpenVolumeByLetter(pPartInfo(DiskTree.Selected.Data).sLetter);
 M.Position:=0;
 M.CopyFrom(Disk,512);
 M.Position := 0;
 M.SaveToFile(Path+diskname+'_mbr.bin');//'\mbr.bin');

 if Pos('FAT',DiskTree.Selected.Text) > 0 then
  begin
  MinSec := pPartInfo(DiskTree.Selected.Data).StartSec;
  //MaxSec := pPartInfo(DiskTree.Selected.Data).StartSec + pPartInfo(DiskTree.Selected.Data).SizeSec - 1;

  Disk.Position := Int64(MinSec) * 512;
  StatusBar1.Panels[0].Text:='Saving BootSector...';
  StatusBar1.Refresh;
  M:=TMemoryStream.Create;
  M.CopyFrom(Disk,512);
  M.Position := 0;
  M.SaveToFile(Path+diskname+partname+'sect0.bin');//'\bootsec.bin');

  (*
  Disk.Position := Int64(MinSec) * 512;
  Disk.ReadBuffer(FATBoot, sizeof(FATBoot));

  Disk.Position := Int64(MinSec + FATBoot.ReservedSectors) * FATBoot.BytesPerSec;
  M.Clear;
  StatusBar1.Panels[0].Text:='Reading FAT1...';
  StatusBar1.Refresh;
  M.CopyFrom(Disk,FATBoot.SectorsPerFat*FATBoot.BytesPerSec);
  StatusBar1.Panels[0].Text:='Saving FAT1...';
  StatusBar1.Refresh;
  M.SaveToFile(Path+diskname+partname+ 'FAT1.bin');

  Disk.Position := Int64(MinSec) + FATBoot.ReservedSectors+FATBoot.SectorsPerFat * Int64(FATBoot.BytesPerSec);
  M.Clear;
  StatusBar1.Panels[0].Text:='Reading FAT2...';
  StatusBar1.Refresh;
  M.CopyFrom(Disk,FATBoot.SectorsPerFat*FATBoot.BytesPerSec);
  StatusBar1.Panels[0].Text:='Saving FAT2...';
  StatusBar1.Refresh;
  M.SaveToFile(Path+diskname+partname+'FAT2.bin');
  *)
  end
 else
 if Pos('NTFS',DiskTree.Selected.Text) > 0 then
  begin
  Disk := pPartInfo(DiskTree.Selected.Data).Disk;

  MinSec := pPartInfo(DiskTree.Selected.Data).StartSec;
  //MaxSec := pPartInfo(DiskTree.Selected.Data).StartSec + pPartInfo(DiskTree.Selected.Data).SizeSec - 1;

  Disk.Position := Int64(MinSec) * 512;
  StatusBar1.Panels[0].Text:='Saving BootSector...';
  StatusBar1.Refresh;
  M:=TMemoryStream.Create;
  M.CopyFrom(Disk,512);
  M.Position := 0;
  M.SaveToFile(Path+diskname+partname+'sect0.bin');

  end;
 end
else MessageDlg('Please choose a partition.',mtInformation,[mbOK],0);

StatusBar1.Panels[0].Text:='done.';
StatusBar1.Refresh;
end;

procedure TMainForm.DumpToFileClick(Sender: TObject);
begin
(*
if Pos('FAT',DiskTree.Selected.Text) > 0 then
with TFAT32BrowseForm.Create(nil) do
 begin
 FAT32 := TFAT32.Create(pPartInfo(DiskTree.Selected.Data)^);
 ReadDirectory(0);
 Show;
 end
else
if Pos('NTFS',DiskTree.Selected.Text) > 0 then
with TNTFSBrowseForm.Create(nil) do
 begin
 NTFS := TNTFS.Create(pPartInfo(DiskTree.Selected.Data)^);
 NTFS.partname:=DiskTree.Selected.Text;
 Show;
 logfile := TFileStream.Create('c:\dbuddy.log', fmCreate or fmOpenWrite or fmShareDenyWrite);
 ProcessDirectory(5, True, logfile);
 logfile.Free;
 end
*)
Application.MessageBox('todo','todo');
end;

procedure TMainForm.InfoDrive(Sender:TObject; s:string; data:PPartinfo);
var p:TPartInfo;
begin
  p:=pPartInfo(Data)^;
  if Pos(' Disk',s)=1 then
  begin
    with TDiskPropForm.Create(nil) do
      if p.Disk.Physical then
      begin
        diskno:=p.Disk.Number;
        Caption:=s;
        Show;
        AddBSInfo('TotalSectors', IntToStr(p.SizeSec));
        AddBSInfo('Cylinders', IntToStr(p.Disk.DiskGeometry.Cylinders.QuadPart));
        AddBSInfo('TracksPerCylinder', IntToStr(p.Disk.DiskGeometry.TracksPerCylinder));
        AddBSInfo('SectorsPerTrack', IntToStr(p.Disk.DiskGeometry.SectorsPerTrack));
        AddBSInfo('BytesPerSector', IntToStr(p.Disk.DiskGeometry.BytesPerSector));
        AddBSInfo('Size', IntToStr(p.Disk.Size)+' ('+IntToSize(p.Disk.Size)+')');
     end;
  end else begin
    if Pos('FAT',s) > 0 then
     with TFAT32PropsForm.Create(nil) do
      begin
      FAT32 := TFAT32.Create(p);
      Caption:=s;
      Show;
      end
    else
    if Pos('NTFS',s) > 0 then
     with TNTFSPropsForm.Create(nil) do
      begin
      NTFS := TNTFS.Create(p);
      Caption:=s;
      Show;
      end
  end;
end;

procedure TMainForm.Info1Click(Sender: TObject);
begin
  if (DiskTree.visible) then
  InfoDrive(Sender, Disktree.Selected.Text,Disktree.Selected.Data)
  else
  InfoDrive(Sender, DiskList.Selected.Caption,DiskList.Selected.Data);
end;

procedure TMainForm.SearchDeletedFiles(Sender:TObject; s:string; data:PPartinfo);
begin
if Pos('FAT32',DiskTree.Selected.Text) > 0 then
with TFAT32SearchForm.Create(nil) do
 begin
 PartName:=s;
 FAT32 := TFAT32.Create(pPartInfo(Data)^);
 FAT32.partname:=s;
 caption:='Search deleted - '+DiskTree.Selected.Text; //s;
 Show;
 end
else
if Pos('NTFS',DiskTree.Selected.Text) > 0 then
with TNTFSSearchForm.Create(nil) do
 begin
 PartName:=s;
 NTFS := TNTFS.Create(pPartInfo(Data)^);
 NTFS.partname:=s;
 caption:='Search deleted - '+DiskTree.Selected.Text; //s;
 Show;
 end;
end;

procedure TMainForm.SearchDeletedFiles1Click(Sender: TObject);
begin
  if (DiskTree.visible) then
  SearchDeletedFiles(Sender, inttostr(Disktree.Selected.index),Disktree.Selected.Data)
  else
  SearchDeletedFiles(Sender, inttostr(DiskList.Selected.index),DiskList.Selected.Data);
end;

procedure TMainForm.DiskEditor(Sender: TObject; s: string; data:Pointer);
begin
  with TDiskEditor.Create(Application) do
  begin
    partinfo:=PPartinfo(data)^;
    if (partinfo.partno=0) then
    begin
      partition:=false;
      Disk:=partinfo.Disk;
      if Disk.DiskHandle=0 then
        Disk.OpenVolumePhysical;
      MinSec := 0;
      MaxSec := partinfo.SizeSec;
      CurSec := 0;
      BytesPerSector := Disk.DiskGeometry.BytesPerSector;
      BytesPerCluster := Disk.DiskGeometry.BytesPerSector*4;
      Caption := 'Disk Viewer - '+s;
    end else begin
      Partition := True;
      Disk := partinfo.Disk;
      if Disk.DiskHandle=0 then
        if (Disk.Physical) then
          Disk.OpenVolumePhysical
        else
          Disk.OpenVolumeByLetter(PartInfo.sLetter);
      MinSec := PartInfo.StartSec;
      MaxSec := PartInfo.StartSec + PartInfo.SizeSec - 1;
      CurSec := MinSec;
      BytesPerSector := Disk.DiskGeometry.BytesPerSector;
      BytesPerCluster := Disk.DiskGeometry.BytesPerSector*4;
      Caption := 'Disk Viewer - '+s;
    end;
    UpdateSec;
  end;
end;

procedure TMainForm.DiskEditor2Click(Sender: TObject);
begin
  if (DiskTree.visible) then
  DiskEditor(Sender, Disktree.Selected.Text,DiskTree.Selected.Data)
  else
  DiskEditor(Sender, DiskList.Selected.Caption,DiskList.Selected.Data);
end;

procedure TMainForm.BrowseFiles(Sender:TObject; s:string; data:PPartinfo);
begin
  if Pos('FAT32',s) > 0 then
      with TFAT32BrowseForm.Create(nil) do
      begin
        PartName:=s;
        FAT32 := TFAT32.Create(pPartInfo(Data)^);
        caption:='FAT Browser - ' +s;
        Show;
        ReadDirectory(0);
  end else
  if Pos('NTFS',s) > 0 then
      with TNTFSBrowseForm.Create(nil) do
      begin
        //PartName:=copy(s,1,2)+'\';
        PartName:=IntToStr(data.partno);
        NTFS := TNTFS.Create(pPartInfo(Data)^);
        if NTFS.Disk.DiskHandle=INVALID_HANDLE_VALUE then
          close
        else if NTFS.BootSec.BytesPerSec>0 then
        begin
          NTFS.partname:=IntToStr(data.partno);
          caption:='NTFS Browser - ' +s;
          Show;
          ProcessDirectory(5, False, nil);
        end else
          Close;
  end else
  if Pos('Disk',s) = 1 then
  begin
      MessageDlg('!',mtInformation,[mbok],0);

  end else
    MessageDlg('Only FAT32 and NTFS partitions can be opened/are supported.',mtInformation,[mbOK],0);
end;

procedure TMainForm.FileBrowser1Click(Sender: TObject);
begin
  Application.ProcessMessages;
  ClearMessageBuffers;
  Application.ProcessMessages;
  if (DiskTree.visible) then
  BrowseFiles(Sender, Disktree.Selected.Text   ,Disktree.Selected.Data)
  else
  BrowseFiles(Sender, DiskList.Selected.Caption,DiskList.Selected.Data);
  Application.ProcessMessages;
end;

procedure TMainForm.ViewAttributeDefinations(Sender: TObject; s:string; data:PPartinfo);
begin
  with TNTFSAttrDefForm.Create(Application) do
  begin
    NTFS := TNTFS.Create(pPartInfo(DiskTree.Selected.Data)^);
    NTFS.partname:=DiskTree.Selected.Text;
    caption:='NTFS Attribute Definations - ' + s;
    Show;
  end;
end;

procedure TMainForm.ViewAttributeDefinations1Click(Sender: TObject);
begin
  if (DiskTree.visible) then
    ViewAttributeDefinations(Sender,DiskTree.Selected.Text,DiskTree.Selected.Data)
  else
    ViewAttributeDefinations(Sender,DiskList.Selected.Caption,DiskList.Selected.Data);
end;

procedure TMainForm.MFTEntryViewer1Click(Sender: TObject);
begin
with TNTFSMFTForm.Create(Application) do
begin
  if (DiskTree.visible) then
  begin
    PartName:=DiskTree.Selected.Text;
    NTFS:=TNTFS.Create(pPartInfo(DiskTree.Selected.Data)^);
    NTFS.partname:=DiskTree.Selected.Text;
    //Show;
    UpdateNew;
  end else begin
    PartName:=DiskList.Selected.Caption;
    NTFS:=TNTFS.Create(pPartInfo(DiskList.Selected.Data)^);
    NTFS.partname:=DiskList.Selected.Caption;
    //Show;
    UpdateNew;
  end;
 end;
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// drawstuff ///////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure TMainForm.imMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var p: TPoint;
begin
    p.X:=x;
    p.Y:=y;
    CheckTree(p);
end;

procedure TMainForm.VerticalTextAt(x,y: integer; const s: string);
var lf: TLogFont;
    OldFontHdl,NewFontHdl: HFont;
begin
  if s = '' then exit;
  with im.Canvas do
  begin
    Font.Size:=7;
    if GetObject(Font.Handle, SizeOf(lf), @lf) = 0 then exit;
    lf.lfEscapement := -90 * 10;
    lf.lfOrientation := -90 * 10;
    lf.lfOutPrecision := OUT_TT_ONLY_PRECIS;
    NewFontHdl := CreateFontIndirect(lf);
    OldFontHdl := selectObject(handle,NewFontHdl);
    TextOut(x, y, s);
    selectObject(handle,OldFontHdl);
    DeleteObject(NewFontHdl);
    Font.Size:=8;
  end;
end;

procedure TMainForm.ClearGraph;
var r: TRect;
begin
  r.Top:=0; r.Left:=0;
  r.Right:=im.Width; r.Bottom:=im.Height;
  im.Canvas.Font.Color:=clBlack;
  im.Canvas.Pen.Width:=1;
  im.Canvas.Pen.Color:=clBlack;
  im.Canvas.Brush.Color:=clWindow;
  im.Canvas.Brush.Style:=bsSolid;
  //im.Canvas.FillRect(r);
  im.Canvas.Rectangle(r);
  im.Canvas.Pen.Width:=2;
  im.Canvas.Refresh;
  im.Refresh;
end;

procedure TMainForm.DrawPartition(p: pPartInfo; name: string; extended: Boolean;
                                  noDisks: Integer; first, last:boolean);
var x1, x2, y1, y2: double;
    r   : TRect;
    w, h: integer;
    fa, ts : Int64;
    tf: TLargeInteger;
begin
    if (p.Disk=nil) then exit;
    if (p.StartSec + p.SizeSec>= p.Disk.TotalSectors) and
       (noDisks>p.Disk.Number) and (Name='')
    then exit;
    //if Disk.Number=-1 then exit;
    w:=im.Width;
    h:=im.Height-17;

    //if Pos('Extend', Name)=0 then
    if p.Disk.TotalSectors>0 then
    begin
        x1:=(p.Disk.Number         )*w / noDisks              ;
        x2:=(p.Disk.Number         )*w / noDisks + w / noDisks;
        y1:=(p.StartSec            )*h / p.Disk.TotalSectors;
        y2:=(p.StartSec + p.SizeSec)*h / p.Disk.TotalSectors;

        if name='' then
        begin
          y1:=((p.StartSec + p.SizeSec) / p.Disk.TotalSectors)*h;
          y2:=im.Height-15;
          x1:=x1-4;
          x2:=x2+4;
        end;
    end else begin
        x1:=(p.Disk.Number         )*w / noDisks;
        x2:=(p.Disk.Number         )*w / noDisks + w / noDisks;
        y1:=0;
        y2:=h;
    end;

    r.Left:=Trunc(x1)+3;
    r.Right:=Trunc(x2)-3;
    r.Top:=Trunc(y1)+15;
    r.Bottom:=Trunc(y2)+15-2;

    if (extended) OR (name='') then begin
      r.Left:=r.Left+4;
      r.Right:=r.Right-4;
      if first then
      r.Top:=r.Top+4;
      if last then
      r.Bottom:=r.Bottom-2;
    end;

    if      Pos('FAT'   , Name)<>0 then
      im.Canvas.Brush.Color:=clMedGray
    else if Pos('NTFS'  , Name)<>0 then
      im.Canvas.Brush.Color:=clLtGray
    else if Pos('inux'  , Name)<>0 then
      im.Canvas.Brush.Color:=clGray
    else if Pos('Extend', Name)<>0 then begin
      im.Canvas.Pen.Width:=1;
      im.Canvas.Brush.Color:=cl3DLight;
    end else
      im.Canvas.Brush.Color:=clInactiveCaption;

    im.Canvas.Brush.Style:=bsclear;
    SetBkMode(im.Canvas.Handle, TRANSPARENT);
    im.Canvas.Rectangle(r.Left,r.Top,r.Right,r.Bottom);
    //im.Canvas.Rectangle(r);
    im.Refresh;

    if (name<>'') and (name[2]=':') then
    begin
       tf:=0;
       GetDiskFreeSpaceEx(PChar(LeftStr(name, 2)+'\'), fa, ts, @tf);
       //GetDiskFreeSpace(PChar(LeftStr(name, 2)+'\'), spc, bps, nofc, tnoc);
       r.Left:=r.Left+3;
       r.Right:=r.Left + (r.Right-r.Left) div 3;
       r.Top:=r.Top;
       if (tf>0) then
       begin
         //r.Bottom:= r.Bottom - Trunc(nofc * (r.Bottom-2-r.Top) / tnoc )-2;
         r.Bottom:= r.Bottom - Trunc( (r.Bottom-2-r.Top) * fa / ts )-2;
         im.Canvas.Brush.Color:=clGreen;
         //im.Canvas.Brush.Style:=bsClear;
         //im.Canvas.FillRect(r);
         im.Canvas.Rectangle(r.Left+p.partno*10,r.Top,r.Right+p.partno*10,r.Bottom);
       end;
       im.Canvas.Brush.Color:=clBlack;
       SetBkMode(im.Canvas.Handle, TRANSPARENT);
       ShadowTextOut(im.Canvas, clWhite, r.Left+p.partno*10, r.Top, name[1]+':');

       im.Canvas.Font.Color:=clBlack;
       im.Canvas.Brush.Style:=bsSolid;
       VerticalTextAt( r.Left+p.partno*10+15, r.Top+15, copy(name, pos('] ',name)+1, length(name)) );
       im.Refresh;
    end else begin
       tf:=0;
       //r.Left:=r.Left+3;
       r.Left:=r.Left+3;
       r.Right:=r.Left + (r.Right-r.Left) div 3;
       if p.Disk.TotalSectors>0 then begin
       r.Top:=12+trunc(((p.StartSec)/p.Disk.TotalSectors)*im.Height);
       r.Bottom:=r.Top + trunc((((p.StartSec+p.SizeSec))/p.Disk.TotalSectors)*im.height);
       end else begin
       r.Top:=13;
       r.Bottom:=im.height-15;
       end;
       begin
         //r.Bottom:= r.Bottom - Trunc(nofc * (r.Bottom-2-r.Top) / tnoc )-2;
         r.Top:= r.Top+3;
         r.Bottom:= r.Bottom +5;
         //im.Canvas.Brush.Color:=clGreen;
         //im.Canvas.FillRect(r);
         im.Canvas.Rectangle(r.Left,r.Top,r.Right,r.Bottom);
         im.Refresh;
       end;

       im.Canvas.Brush.Style:=bsClear;
       im.Canvas.Font.Color:=clBlack;
       if first and last and (p.partno=0) then
         VerticalTextAt(r.Left+p.partno*10+15, r.Top+15, name)
       else
         VerticalTextAt(r.Left+p.partno*10+15, r.Top+15, copy(name, pos('] ',name)+1, length(name)) );
       im.Refresh;
    end;

    if Pos('Extend', Name)<>0 then im.Canvas.Pen.Width:=2;

    SetBkMode(im.Canvas.Handle, TRANSPARENT);
    im.Canvas.Font.Color:=clBlack;
    //if ((p.StartSec=0) OR (p.StartSec=63)) and (name<>'') then
    if first and ((p.partno=1) or (p.partno=0)) then
      ShadowTextOut(im.Canvas, clWhite, r.Left+1,1, IntToStr(p.Disk.Number));
    //
    im.Refresh;
end;

procedure TMainForm.DrawPartitionTables;
var h, i, j: Integer;
    DiskNode, SubNode: TTreeNode;
    first, last:boolean;
    lastidx:integer;
begin
  if DiskTree.Items.Count=0 then exit;
  lastidx:=0;
  ClearGraph;
  for h:=0 to DiskTree.Items.Count-1 do
  begin
    if DiskTree.Items[h].Level=0 then
    begin
      im.Canvas.Refresh;
      DiskNode:=DiskTree.Items[h];
      if DiskNode.HasChildren then
      begin
        if (pos(':', DiskNode.Text)=2) then
          DrawPartition(pPartInfo(DiskNode.Data), DiskNode.Text, FALSE, diskcount, TRUE, TRUE);
        for i:=0 to DiskNode.Count-1 do
        begin
          if Pos('Extended', DiskNode.Item[i].Text)>0 then
          begin
            SubNode:=DiskNode.Item[i];
            DrawPartition(pPartInfo(SubNode.Data),
                          SubNode.Text, FALSE, diskcount, TRUE, TRUE);
            for j:=0 to SubNode.Count-1 do
            begin
              first:=j=0;
              last:=j=SubNode.Count-1;
              DrawPartition(pPartInfo(SubNode.Item[j].Data),
                            SubNode.Item[j].Text, TRUE, diskcount, first, last);
            end;
          end else begin
            DrawPartition(pPartInfo(DiskNode.Item[i].Data),
                          DiskNode.Item[i].Text, FALSE, diskcount, TRUE, TRUE);
          end;
          lastidx:=i;

        end;
      end else begin
        DrawPartition(pPartInfo(DiskNode.Data), DiskNode.Text, false, diskcount, TRUE,TRUE);
      end;
    end;
  end; // while/for
  im.Canvas.Refresh;
end;

function TMainForm.ChecKTreeItem(pt:TPoint; p: pPartInfo; name: string; extended: Boolean;
                                  noDisks: Integer; first, last:boolean):boolean;
var x1, x2, y1, y2: double;
    r   : TRect;
    w, h: integer;
begin
     result:=FALSE;
     w:=im.Width; h:=im.Height-15;
     //if Pos('Extend', Name)=0 then
     x1:=(p.Disk.Number         )*w / noDisks;
     x2:=(p.Disk.Number         )*w / noDisks + w / noDisks;
     y1:=(p.StartSec            )*h / p.Disk.TotalSectors;
     y2:=(p.StartSec + p.SizeSec)*h / p.Disk.TotalSectors;

     r.Left:=Trunc(x1)+3;
     r.Right:=Trunc(x2)-3;
     r.Top:=Trunc(y1)+12;
     r.Bottom:=Trunc(y2)+15-2;

     if extended then begin
       r.Left:=r.Left+4;
       r.Right:=r.Right-4;
       if first then
       r.Top:=r.Top+4;
       if last then
       r.Bottom:=r.Bottom;
     end;

     if PtInRect(r, pt) then result:=True;
end;

procedure TMainForm.CheckTree(pt: Tpoint);
var h, i, j: Integer;
    DiskNode, SubNode: TTreeNode;
    first, last:boolean;
begin
  for h:=0 to DiskTree.Items.Count-1 do begin
    if DiskTree.Items[h].Level=0 then
    begin
      DiskNode:=DiskTree.Items[h];
      for i:=0 to DiskNode.Count-1 do
      begin
        first:=i=0;
        last:=i=DiskNode.Count-1;
        if CheckTreeItem(pt, pPartInfo(DiskNode.Item[i].Data),
                         DiskNode.Item[i].Text, True, diskcount, first, last)
        then
            DiskNode.Item[i].Selected:=TRUE;

        if Pos('Extended', DiskNode.Item[i].Text)>0 then
        begin
          SubNode:=DiskNode.Item[i];
          for j:=0 to SubNode.Count-1 do
          begin
            first:=j=0;
            last:=j=SubNode.Count-1;
            if CheckTreeItem(pt, pPartInfo(SubNode.Item[j].Data),
                             SubNode.Item[j].Text, True, diskcount, first, last)
            then
                SubNode.Item[j].Selected:=TRUE;
          end;
        end;
      end;

    end;
  end; // while/for
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// disk and partition stuff ////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

// make a list of all driveletters with partition-info
procedure TMainForm.FillLeftDriveLetters;
  function CTL_CODE(DeviceType:cardinal; FunctionNo, Method, Access: DWORD):cardinal;
  begin      //((DeviceType)  << 16) |  ((Access) << 14)  |   ((Function) << 2) | (Method)
    result:= ((DeviceType) shl 16) OR ((Access) shl 14) OR  ((FunctionNo) shl 2) OR (Method);
  end;
const FILE_ANY_ACCESS               = 0;
const FILE_READ_ACCESS              = $0001;
const METHOD_BUFFERED               = 0;
const FILE_DEVICE_DISK              = $00000007;
const IOCTL_DISK_BASE               = FILE_DEVICE_DISK;
const FILE_DEVICE_MASS_STORAGE      = $0000002d;
const IOCTL_STORAGE_BASE            = FILE_DEVICE_MASS_STORAGE;
var s:DWORD;
    Letters, CurrentDrive : PChar;
    d1, d2, thisserial:string;
    lpBytesReturned:DWORD;
    DiskHandle: THandle;
    Disk:TDisk;
    pinfo:TPARTITION_INFORMATION;
    pinfoex:TPartitionInformationEx;
    sdn:TSTORAGE_DEVICE_NUMBER;
    IOCTL_DISK_GET_PARTITION_INFO:Cardinal;
    IOCTL_STORAGE_GET_DEVICE_NUMBER:Cardinal;
    cDriveType:Cardinal;
begin
  leftDriveLetters.Lines.Clear;
  S := 255;
  GetMem(Letters, Succ(S));
  GetLogicalDriveStrings(S, Letters);
  CurrentDrive := Letters;
  // debug todo skip first drive - floppy
  //CurrentDrive := @CurrentDrive[lstrlen(CurrentDrive) + 1];

  while CurrentDrive[0]<>#0 do
  begin
    StatusBar1.Panels[0].Text:='Scanning Disk ' + CurrentDrive[0]+':';
    StatusBar1.Panels[0].Width:=StatusBar1.Canvas.TextWidth(StatusBar1.Panels[0].Text)+70;
    StatusBar1.Refresh;
    cDriveType:=GetDriveType(PWideChar(CurrentDrive[0]+':\'));
    DiskHandle:=CreateFile(PChar('\\.\'+CurrentDrive[0]+':'),GENERIC_READ,
        FILE_SHARE_READ OR FILE_SHARE_WRITE,nil,OPEN_EXISTING,0,0);
    if DiskHandle<>INVALID_HANDLE_VALUE then
    begin
      IOCTL_DISK_GET_PARTITION_INFO   := CTL_CODE(IOCTL_DISK_BASE   , $0001, METHOD_BUFFERED, FILE_READ_ACCESS);
      if (DeviceIoControl(DiskHandle, IOCTL_DISK_GET_PARTITION_INFO, nil, 0,
              @pinfo, sizeof(pinfo)+4, lpBytesReturned, nil)) then
      begin
          // device with partitions
          IOCTL_STORAGE_GET_DEVICE_NUMBER := CTL_CODE(IOCTL_STORAGE_BASE, $0420, METHOD_BUFFERED, FILE_ANY_ACCESS);
          if (DeviceIoControl(DiskHandle, IOCTL_STORAGE_GET_DEVICE_NUMBER, nil, 0,
                  @sdn, sizeof(sdn), lpBytesReturned, nil)) then
          begin
            if (sdn.DeviceType=7) OR (sdn.DeviceType=8) then
            begin
              leftDriveLetters.Lines.Add(
                'letter='      +CurrentDrive[0]              + ',' +
                'disk='        +inttostr(sdn.DeviceNumber)   + ',' +
                'partition='   +inttostr(pinfo.PartitionNumber) + ',' +
                'size='        +inttostr(pinfo.PartitionLength.QuadPart) + ',' +
                'startoffset=' +inttostr(pinfo.StartingOffset.QuadPart div 512) + ',' +
                'drivetype='   +inttostr(cDriveType));
            end else begin
              leftDriveLetters.Lines.Add(
                'letter='      +CurrentDrive[0]              + ',' +
                'disk='        +inttostr(sdn.DeviceNumber)   + ',' +
                'partition='   +inttostr(pinfo.PartitionNumber) + ',' +
                'size='        +inttostr(pinfo.PartitionLength.QuadPart) + ',' +
                'startoffset=' +inttostr(pinfo.StartingOffset.QuadPart div 512) + ',' +
                'drivetype='   +inttostr(cDriveType));
            end;
          end else begin
              leftDriveLetters.Lines.Add(
                'letter='      +CurrentDrive[0]              + ',' +
                'size='        +inttostr(pinfo.PartitionLength.QuadPart) + ',' +
                'startoffset=' +inttostr(pinfo.StartingOffset.QuadPart div 512) + ',' +
                'drivetype='   +inttostr(cDriveType));
          end;

      end else begin

          // device w/o partitions
          if (DeviceIoControl(DiskHandle, IOCTL_DISK_GET_PARTITION_INFO_EX, nil, 0,
                  @pinfoex, sizeof(pinfoex)+4, lpBytesReturned, nil)) then
          begin
              IOCTL_STORAGE_GET_DEVICE_NUMBER := CTL_CODE(IOCTL_STORAGE_BASE, $0420, METHOD_BUFFERED, FILE_ANY_ACCESS);
              if (DeviceIoControl(DiskHandle, IOCTL_STORAGE_GET_DEVICE_NUMBER, nil, 0,
                      @sdn, sizeof(sdn), lpBytesReturned, nil)) then
              begin
                if (sdn.DeviceType=7) OR (sdn.DeviceType=8) then
                begin
                  leftDriveLetters.Lines.Add(
                    'letter='      +CurrentDrive[0]              + ',' +
                    'disk='        +inttostr(sdn.DeviceNumber)   + ',' +
                    'partition='   +inttostr(pinfoex.PartitionNumber) + ',' +
                    'size='        +inttostr(pinfoex.PartitionLength) + ',' +
                    'startoffset=' +inttostr(pinfoex.StartingOffset div 512) + ',' +
                    'drivetype='   +inttostr(cDriveType));
                end;
              end else begin
                  leftDriveLetters.Lines.Add(
                    'letter='      +CurrentDrive[0]              + ',' +
                    'size='        +inttostr(pinfoex.PartitionLength) + ',' +
                    'startoffset=' +inttostr(pinfoex.StartingOffset div 512));
              end;

          end else begin

          end;

      end;
      CloseHandle(DiskHandle);
    end else begin
              leftDriveLetters.Lines.Add(
                'letter='      +CurrentDrive[0]              + ',' +
                'disk='        +inttostr(sdn.DeviceNumber)   + ',' +
                'drivetype='   +inttostr(cDriveType));
    end;
    CurrentDrive := @CurrentDrive[lstrlen(CurrentDrive) + 1];
  end;
  FreeMem(Letters);
end;

// test list of all driveletters with partition-info
function TMainForm.GetDriveLetter(p: TPartInfo; StartSector:int64):string;
var h:integer;
    line:string;
    kt:TStrings;
    wantedDiskNo:string;
    wantedSector:string;
    wantedPartno:string;
    wantedSize:string;
begin
    result:='';
    p.sLetter:='';
    wantedDiskNo:=inttostr(p.Disk.Number);
    wantedSector:=inttostr(StartSector);
    wantedSize:=inttostr(p.SizeSec);

    kt:=TStringList.Create;
    for h:=0 to leftDriveLetters.Lines.Count-1 do
    begin
      kt.CommaText:=leftDriveLetters.LineS[h];
      if (kt.Values['disk']=wantedDiskNo) and
         (kt.Values['startoffset']=wantedSector) then
      begin
        result:=kt.Values['letter'];// MainForm.leftDriveLetters.Lines[h][1];
        //drivetype:=MediaTypes[ strtoint(kt.Values['drivetype']) ] ;

        leftDriveLetters.Lines.Delete(h);
        break;
      end;
    end;
    kt.Free;

    if result='' then
    begin
        kt:=TStringList.Create;
        for h:=0 to leftDriveLetters.Lines.Count-1 do
        begin
          kt.CommaText:=leftDriveLetters.LineS[h];
          if (kt.Values['size']=wantedSize) and
             (kt.Values['startoffset']=wantedSector) then
          begin
            result:=kt.Values['letter'];// MainForm.leftDriveLetters.Lines[h][1];
            //drivetype:=MediaTypes[ strtoint(kt.Values['drivetype']) ] ;

            leftDriveLetters.Lines.Delete(h);
            break;
          end;
        end;
        kt.Free;
    end;
end;

function TMainForm.GetNonPhysicalDriveLetters(parent: TTreeNode):string;
var i: integer;
    Disk:TDisk;
    cDriveType: Cardinal;
    PartInfo: pPartInfo;
    fa, ts: int64; // FreeAvailableSpace, TotalSpace,
    tf: TLargeInteger;
    Nodename,localname: string;
    kt:TStrings;
begin
  kt:=TStringList.Create;
  for i:=0 to leftDriveLetters.Lines.Count-1 do
  begin
      kt.CommaText:=leftDriveLetters.LineS[i];

      cDriveType := GetDriveType(PChar(kt.Values['letter'] + ':\'));
      case cDriveType of { Positive Werte bedeuten gltige Laufwerke }
         { DRIVE_UNKNOWN = 0;
           DRIVE_NO_ROOT_DIR = 1;
           DRIVE_REMOVABLE = 2;
           DRIVE_FIXED = 3;
           DRIVE_REMOTE = 4;
           DRIVE_CDROM = 5;
           DRIVE_RAMDISK = 6;}
         DRIVE_CDROM, DRIVE_REMOTE, DRIVE_UNKNOWN:
           begin
             continue;
           end;

         DRIVE_REMOVABLE, DRIVE_FIXED, DRIVE_RAMDISK, DRIVE_NO_ROOT_DIR:
           begin

             case cDriveType of // Positive Werte bedeuten gltige Laufwerke
               DRIVE_REMOVABLE:localname:=' <removable> ';
               DRIVE_FIXED:localname:=' <fixed> ';
               DRIVE_RAMDISK:localname:=' <ramdisk> ';
             end;

             GetDiskFreeSpaceEx(PChar(kt.Values['letter']+':\'), fa, ts, @tf);
             if (ts=0) then begin
                 localname:=kt.Values['letter']+':\' + localname + ' -empty- ';
                 New(PartInfo);
                 PartInfo.Disk := Disk;
                 PartInfo.StartSec := 0;
                 PartInfo.SizeSec := 0;
                 PartInfo.partno := 0;

                 nodename:=localname;
                 parent := DiskTreeAddItem(nil, nodename, 2, PartInfo);
                 DiskListAddItem(NodeName,2,PartInfo);

             end else begin
                 Disk := TDisk.Create(kt.Values['letter'][1], diskcount);
                 Disk.Number:=diskcount;
                 if (Disk.Size=0) then
                 begin
                   //Size := DiskGeometryEx.DiskSize; // TotalSectors*512; //DiskGeometry.BytesPerSector;
                   //SurPlusSectors := trunc(Size / 512) - TotalSectors;
                   //TotalSectors := TotalSectors + SurPlusSectors;

                   Disk.Size := ts; //dwTotalClusters * dwSectorsPerCluster * dwBytesPerSector;
                   Disk.TotalSectors:=Trunc(Disk.Size  / Disk.DiskGeometry.BytesPerSector);
                   Disk.SurPlusSectors := 0;
                 end;

                 New(PartInfo);
                 PartInfo.Disk := Disk;
                 PartInfo.StartSec := 0;
                 PartInfo.SizeSec := Disk.TotalSectors;
                 PartInfo.partno := 0;

                 nodename:=' nonphys Disk'+inttostr(Disk.Number)+' - '+IntToSize(Disk.Size)+localname;
                 parent := DiskTreeAddItem(nil, nodename, 2, PartInfo);
                 DiskListAddItem(NodeName,2,PartInfo);

                 New(PartInfo);
                 PartInfo.Disk := Disk;
                 PartInfo.StartSec := 0;
                 PartInfo.SizeSec := Disk.TotalSectors;
                 PartInfo.sLetter := kt.Values['letter'];
                 GetPartitionInfo(PartInfo.sLetter, PartInfo.sVolName, PartInfo.sFSName, PartInfo.sVolSerial);
                 PartInfo.partno := 1;
                 Nodename:=PartInfo.sLetter+': ['+PartInfo.sFSName+'] "'+PartInfo.sVolname+'" ';
                 if Nodename[2]=':' then begin
                   Nodename:=Nodename+IntToSize(Disk.Size);
                   Nodename:=Nodename+' | '+IntToSize(tf)+' free';
                 end;
                 DiskTreeAddItem(Parent, NodeName, 1, PartInfo);
                 DiskListAddItem(NodeName,1,PartInfo);
                 Disk.CloseVolume;
                 Inc(diskcount);
             end;

             (*
             // --- now scan partitiontable ---
             StatusBar1.Panels[0].Text:='Reading Partitions on ' + Disk.Name;
             StatusBar1.Refresh;
             if Disk.TotalSectors <> 0 then begin
                 bytesPerSec := Disk.Size div Disk.TotalSectors;
                 ptno:=0;
                 ScanPT(Disk, ptno, bytesPerSec, 0, Disk.TotalSectors, DiskNode);
                 DiskNode.Text := CurrentDrive[0] + ':' + DiskNode.Text;
             end;
             *)
           end;
      end; // case
  end;
  kt.free;
end;

// Scan Disks For Partitions
function TMainForm.ScanForPartitions(Disk: TDisk; bytesPerSec: Integer; localStartSect: Int64;
                                     extendedPart:Boolean; physpart:byte; var Parent: TTreeNode):byte;
var  PartInfo    : PPartInfo;
     SubPartInfo : PPartInfo;
     SubNode     : TTreeNode;
     J           : Integer;
     fa, ts      : Int64;
     tf          : TLargeInteger;
     PartOffSet  : Cardinal;
     nodename,zw : string;
     //PartInfoGpt : TPartitionInformationGpt;
     //PartInfoEx  : TPartitionInformationEx;
     GUIDPartTableEntry : TGUIDPartitionTableEntry;
     iGTPcount   : integer;
begin
  result:=0;
  New(PartInfo);
  PartInfo.Disk := Disk;

  // read partition table (first sector on disk or extended partition's first sector)
  Disk.Position := localStartSect * bytesPerSec;
  Disk.Read(Disk.SecBuf,2048);
  //Disk.Position := Disk.Position+512;

  // partitiontable-flag
  if (Disk.SecBuf[510] <> $55) or (Disk.SecBuf[511] <> $aa) then
    exit;

  Move(Disk.SecBuf[PartitionTableOffset], PartInfo^.PartitionTable, SizeOf(TPartitionTable));
  for J := 1 to 4 do begin
      if ( (PartInfo.PartitionTable[J].PartitionType = $0F) or
           (PartInfo.PartitionTable[J].PartitionType = $05)    )
      then begin
         // 0x0F EXTENDED EPBR extended partition boot record
         // 0x05 EXTENDED XINT13
         if not extendedPart then
           Inc(physpart);

         if not extendedPart then physpart:=4;

         New(SubPartInfo);
         SubPartInfo.Disk          := Disk;
         SubPartInfo.StartSec      := localStartSect + PartInfo.PartitionTable[J].StartSect;
         SubPartInfo.SizeSec       := PartInfo.PartitionTable[J].SizeSect;
         SubPartInfo.partno        := physpart;
         SubPartInfo.PartitionTable:= PartInfo.PartitionTable;

         if (PartInfo.PartitionTable[J].PartitionType = $0F) or (PartitionDetails1.Checked) then
         begin
           nodename := GetFSName(PartInfo.PartitionTable[J])+' '+IntToSize(SubPartInfo.SizeSec*bytesPerSec);
           SubNode  := DiskTreeAddItem(parent,nodename,0,SubPartInfo);
           DiskListAddItem(nodename,0,SubPartInfo);
           if (physpart>=4) and (extendedpart) then
             SubNode:=parent;
         end else begin
           SubNode:=parent;
         end;

         PartOffSet:=0;
         if j=1 then
           // first partition
           PartOffset:=localStartSect + PartInfo.PartitionTable[1  ].StartSect
         else if (PartInfo.PartitionTable[J].PartitionType = $0F) then
           // 0x0F EXTENDED EPBR extended partition boot record
           PartOffset:=localStartSect + PartInfo.PartitionTable[J  ].StartSect
         else if (PartInfo.PartitionTable[J].PartitionType = $05) then
           // 0x05 EXTENDED XINT13
           PartOffset:=localStartSect + PartInfo.PartitionTable[J-1].StartSect + PartInfo.PartitionTable[J-1].SizeSect;
         ScanForPartitions(Disk, bytesPerSec, PartOffSet, TRUE, physpart, SubNode)

      end else if (PartInfo.PartitionTable[J].SizeSect <> $00) then
      begin
         // its a partition
         Inc(physpart);
         New(SubPartInfo);
         SubPartInfo.Disk := Disk;

         if (PartInfo.PartitionTable[J].PartitionType = $EE) and
            (Disk.SecBuf[512]=$45) and (Disk.SecBuf[513]=$46) and
            (Disk.SecBuf[514]=$49) and (Disk.SecBuf[515]=$20) and
            (Disk.SecBuf[516]=$50) and (Disk.SecBuf[517]=$41) and
            (Disk.SecBuf[518]=$52) and (Disk.SecBuf[519]=$54)
         then begin

             // GTP GUID Partition scheme
             iGTPcount:=0;
             Move(Disk.SecBuf[1024], GUIDPartTableEntry, SizeOf(TGUIDPartitionTableEntry));
             while (GUIDPartTableEntry.StartingLBA>=0) and
                   (GUIDPartTableEntry.EndingLBA>0)
             do
             begin
                 if iGTPcount>0 then
                   if (GUIDPartTableEntry.StartingLBA=PartInfo.PartitionTable[iGTPcount-1].StartSect) then
                     break;

                 SubPartInfo.StartSec:=GUIDPartTableEntry.StartingLBA;
                 SubPartInfo.SizeSec:=GUIDPartTableEntry.EndingLBA - GUIDPartTableEntry.StartingLBA;
                 SubPartInfo.partno:=physpart;

                 PartInfo.PartitionTable[iGTPcount].StartSect:=Cardinal(SubPartInfo.StartSec);
                 PartInfo.PartitionTable[iGTPcount].SizeSect:=SubPartInfo.SizeSec;
                 PartInfo.PartitionTable[iGTPcount].PartitionType:=GUIDPartTableEntry.PartitionTypeGUID[0];
                 SubPartInfo.PartitionTable:=PartInfo.PartitionTable;

                 SubPartInfo.sLetter := GetDriveLetter(SubPartInfo^,SubPartInfo.StartSec);

                 if (SubPartInfo.sLetter<>'') then
                 begin
                   GetPartitionInfo(SubPartInfo.sLetter, SubPartInfo.sVolName, SubPartInfo.sFSName, SubPartInfo.sVolSerial);
                   if SubPartInfo.sFSName='' then
                     nodename:=SubPartInfo.sLetter+': ' +GetFSName(PartInfo.PartitionTable[iGTPcount]) + ' "' + GUIDPartTableEntry.PartitionName + '" - VolumeError'
                   else
                     nodename:=SubPartInfo.sLetter+': '+SubPartInfo.sFSName+ ' "' +SubPartInfo.sVolname+'"';
                 end else begin
                   SubPartInfo.sFSName:=GetFSName(PartInfo.PartitionTable[iGTPcount]);
                   nodename:=GUIDPartTableEntry.PartitionName;
                   nodename:=SubPartInfo.sFSName + ' "' + nodename+'"';
                 end;
                 nodename:=ReplaceAllStringsInString(nodename,'NTFS','[NTFS]');
                 nodename:=ReplaceAllStringsInString(nodename,'FAT32','[FAT32]');

                 nodename:=nodename+' '+IntToSize(SubPartInfo.SizeSec*bytesPerSec);
                 if SubPartInfo.sLetter<>'' then begin
                     fa:=0;ts:=0;tf:=0;
                     GetDiskFreeSpaceEx(PChar(SubPartInfo.sLetter+':\'), fa, ts, @tf);
                     if (fa=0) and (ts=0) and (tf=0) then
                       nodename:=nodename+' - PartitionError'
                     else
                       nodename:=nodename+' | '+IntToSize(fa)+' free';
                 end;

                 if (parent.Level=0) and (Pos(' <GPT>',parent.Text)=0) then
                 begin
                   zw:=parent.Text;
                   Insert(' <GPT>', zw, 6);
                   parent.Text:=zw;
                 end;

                 DiskTreeAddItem(parent,nodename,1,SubPartInfo);
                 DiskListAddItem(nodename,1,SubPartInfo);

                 Inc(iGTPcount);
                 Move(Disk.SecBuf[1024+128*iGTPcount], GUIDPartTableEntry, SizeOf(TGUIDPartitionTableEntry));

                 Inc(physpart);
                 New(SubPartInfo);
                 SubPartInfo.Disk := Disk;
             end;



         end else begin

             // MBR partition scheme
             if iGTPcount>0 then break;

             SubPartInfo.sFSName:=GetFSName(PartInfo.PartitionTable[J]);
             SubPartInfo.StartSec:=localStartSect + PartInfo.PartitionTable[J].StartSect;
             SubPartInfo.SizeSec:=PartInfo.PartitionTable[J].SizeSect;
             SubPartInfo.partno := physpart;
             SubPartInfo.PartitionTable:=PartInfo.PartitionTable;
             SubPartInfo.sLetter:=GetDriveLetter(SubPartInfo^,SubPartInfo.StartSec);
             if (PartInfo.PartitionTable[J].SizeSect > Disk.TotalSectors) then begin
               //Disk.TotalSectors
               SubPartInfo.SizeSec  := PartInfo.PartitionTable[J].SizeSect;
               nodename:='SizeError - '+SubPartInfo.sFSName;
             end else begin
               SubPartInfo.SizeSec  := PartInfo.PartitionTable[J].SizeSect;
               nodename:= SubPartInfo.sFSName;
             end;

             // C: [fsname] "name"
             if (SubPartInfo.sLetter<>'') then
             begin
               GetPartitionInfo(SubPartInfo.sLetter, SubPartInfo.sVolName, SubPartInfo.sFSName, SubPartInfo.sVolSerial);
               if nodename='' then
                 nodename:=SubPartInfo.sLetter+': ' + GetFSName(PartInfo.PartitionTable[J])     +' -  VolumeError'
               else
                 nodename:=SubPartInfo.sLetter+': '+nodename+' "'+SubPartInfo.sVolname+'"';
             end else begin
                 nodename:=SubPartInfo.sFSName;
             end;
             nodename:=ReplaceAllStringsInString(nodename,'NTFS','[NTFS]');
             nodename:=ReplaceAllStringsInString(nodename,'FAT32','[FAT32]');

             // 30.0GB
             nodename:=nodename+' - '+IntToSize(SubPartInfo.SizeSec*bytesPerSec);
             if SubPartInfo.sLetter<>'' then
             begin
                 fa:=0;ts:=0;tf:=0;
                 GetDiskFreeSpaceEx(PChar(SubPartInfo.sLetter+':\'), fa, ts, @tf);
                 // (8.2GB free)
                 if (fa=0) and (ts=0) and (tf=0) then
                   nodename:=nodename+' - PartitionError '
                 else
                   nodename:=nodename+' | '+IntToSize(tf)+' free ';
             end;
             if (parent.Level=0) and (Pos(' <MBR>',parent.Text)=0) then
             begin
                 zw:=parent.Text;
                 Insert(' <MBR>', zw, 6);
                 parent.Text:=zw;
             end;

             DiskTreeAddItem(parent,nodename,1,SubPartInfo);
             DiskListAddItem(nodename,1,SubPartInfo);
         end;

     end;
  end;
  result:=physPart;
end; // sub ScanPT(..) ende

procedure TMainForm.ScanDisksForPartitions;
var I                 : Integer;
    bytesPerSec       : Integer;
    PTNo              : integer;
    DiskNode          : TTreeNode;
    PartInfo          : pPartInfo;
    Letters, CurrentDrive : PChar;
    DiskHandle: THandle;
    Disk:TDisk;
    nodename:string;
    physicalDisks:integer;
begin
  FillLeftDriveLetters;
  physicalDisks:=0;
  for I := 0 to 255 do
  begin
    StatusBar1.Panels[0].Text:='Reading Disk #'+inttostr(i)+'...';
    StatusBar1.Panels[0].Width:=StatusBar1.Canvas.TextWidth(StatusBar1.Panels[0].Text)+70;
    StatusBar1.Refresh;
    Application.ProcessMessages;

    if Win32Platform=VER_PLATFORM_WIN32_NT then begin
      //DiskHandle := CreateFile(pChar('\\.\PhysicalDrive' + IntToStr(I)), , FILE_SHARE_READ, nil, OPEN_EXISTING, 0, 0)
      DiskHandle := CreateFile(pchar('\\.\PhysicalDrive' + IntToStr(I)),
                               GENERIC_READ,
                               FILE_SHARE_READ or FILE_SHARE_WRITE,
                               nil, OPEN_EXISTING, 0, 0)
    end else begin
      //Handle := CreateFile(pchar('\\.\PhysicalDrive' + IntToStr(DiskNumber)), GENERIC_READ, FILE_SHARE_READ   , nil, OPEN_EXISTING, 0, 0);
      //Handle := CreateFile(pchar('\\.\INT13EXT.VXD'), 0, 0, nil, 0, FILE_FLAG_DELETE_ON_CLOSE, 0);
      DiskHandle := CreateFile(pchar('\\.\vwin32'), 0, 0, nil, 0, FILE_FLAG_DELETE_ON_CLOSE, 0);
    end;

    if DiskHandle = INVALID_HANDLE_VALUE then begin
        Break;
        continue;
    end else begin
        //ok, the disk works, close and create new node
        CloseHandle(DiskHandle);
        DiskHandle:=0;
        Disk := TDisk.Create(i);
        if Disk.TotalSectors>0 then begin
            StatusBar1.Panels[0].Text:='Reading Disk #'+inttostr(i)+' ('+Disk.Name+') ...';
            StatusBar1.Panels[0].Width:=StatusBar1.Canvas.TextWidth(StatusBar1.Panels[0].Text)+50;
            StatusBar1.Refresh;
            Application.ProcessMessages;

            New(PartInfo);
            PartInfo.Disk:=Disk;
            PartInfo.StartSec := 0;
            PartInfo.SizeSec := Disk.TotalSectors;
            PartInfo.partno := 0;

            nodename:='disk'+IntToStr(Disk.Number)+' <'+
              lowercase(MediaTypes[Disk.DiskGeometry.MediaType])+'> '+
              IntToSize(Disk.Size)+' ' +
              Disk.Name;

            DiskNode := DiskTreeAddItem(nil, nodename, 2, PartInfo);
            DiskListAddItem(NodeName,2,PartInfo);
            bytesPerSec := Disk.Size div Disk.TotalSectors;
            // now scan partitiontable
            PTNo := ScanForPartitions(Disk, bytesPerSec, 0, FALSE, 0, DiskNode);
            Disk.CloseVolume;
            Inc(diskcount);
        End;
    end;
    Inc(physicalDisks);
  end;

  Application.ProcessMessages;
  MainForm.Refresh;

  if (diskcount+physicalDisks = 0) then
    MessageDlg('No Disk found. Do you have admin rights?',mtError,[mbOK],0)
  else
    // drives, that cannot be opened with "\\.\PhysicalDrive"
    GetNonPhysicalDriveLetters(DiskNode);

  if (physicalDisks=0) then
    StatusBar1.Panels[0].Text:='!!! no physical Disks found !!!'
  else
    StatusBar1.Panels[0].Text:=IntToStr(diskcount) + ' Disks found';
  StatusBar1.Canvas.Font.Style:=[fsBold];
  StatusBar1.Panels[0].Width:=StatusBar1.Canvas.TextWidth(StatusBar1.Panels[0].Text)+40;

  StatusBar1.Panels[1].Text:=IntToStr(diskcount-physicalDisks) + ' nonPhysical Disks';
  StatusBar1.Refresh;
end;

procedure TMainForm.RefreshDrivelist1Click(Sender: TObject);
var i:integer;
begin
  MainMenu1.Items.Enabled:=false;

  StatusBar1.Canvas.Font.Style:=[fsBold];
  StatusBar1.Panels[0].Text:='Clear...';
  StatusBar1.Panels[0].Width:=StatusBar1.Canvas.TextWidth(StatusBar1.Panels[0].Text)+40;
  StatusBar1.Refresh;

  ClearGraph;
  im.Refresh;

  diskcount:=0;
  DiskTree.Items.Clear;
  DiskList.Items.Clear;
  StatusBar1.Panels[0].Text:='Scan Disks for Partitions...';
  StatusBar1.Panels[0].Width:=StatusBar1.Canvas.TextWidth(StatusBar1.Panels[0].Text)+40;
  StatusBar1.Refresh;

  ScanDisksForPartitions;
  DiskTree.FullExpand;
  DiskTree.Refresh;

  if DiskList.Items.Count>0 then begin
  DiskList.Items[0].Selected:=true;
  DiskTree.Items[0].Selected:=true;
  end;
  StatusBar1.Panels[0].Text:='Redraw...';
  StatusBar1.Panels[0].Width:=StatusBar1.Canvas.TextWidth(StatusBar1.Panels[0].Text)+40;
  StatusBar1.Refresh;
  RedrawPartitions; // includes DrawPartitionTables;

  MainMenu1.Items.Enabled:=true;
end;

end.

