unit NTFSAttrDef;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, NTFS, ImgList;

type

  TNTFSAttrDefFlags = set of (afIndexed=1,afResident=6,afResidentOrNonResident=7,afAlign=31);

  TNTFSAttrDef = packed record
    Name: array [1..64] of WideChar;
    TypeOfAttr: Cardinal;
    DisplayRule: Cardinal;
    CollationRule: Cardinal;
    Flags: TNTFSAttrDefFlags;
    MinSize: Int64;
    MaxSize: Int64;
    end;

  TNTFSAttrDefForm = class(TForm)
    View: TListView;
    ImageList2: TImageList;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  public
    NTFS: TNTFS;
  end;

var
  NTFSAttrDefForm: TNTFSAttrDefForm;

implementation

{$R *.dfm}

function NTFSAttrDefFlagsToStr(Flags: TNTFSAttrDefFlags): string;
begin
Result := '';
if afIndexed in Flags then
Result := Result + 'indexed, ';
if afResident in Flags then
Result := Result + 'resident, ';
if afResidentOrNonResident in Flags then
Result := Result + 'resident or non-resident, ';
if Result <> '' then
Delete(Result,Length(Result)-1,2)
else Result := '(none)';
end;

procedure TNTFSAttrDefForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
ntfs.Free;
Release;
end;

procedure TNTFSAttrDefForm.FormShow(Sender: TObject);
var
MFT: TMFTEntry;
I: Integer;
M: TMemoryStream;
AttrDef: TNTFSAttrDef;
Item: TListItem;
begin
MFT := NTFS.ReadMFTEntry(4);
I := MFT.IndexOfAttrib(NTFS_AttribID_Data);
if I > -1 then
 begin
 M := NTFS.ReadFile(MFT.Attrib[I],mft.InfoStdHdr);
 M.ReadBuffer(AttrDef,SizeOf(TNTFSAttrDef));
  repeat
  Item := View.Items.Add;
  Item.Caption := AttrDef.Name;
  Item.SubItems.Add(IntToHex(AttrDef.TypeOfAttr,2) + ' (hex)');
  Item.SubItems.Add(IntToHex(AttrDef.DisplayRule,2) + ' (hex)');
  Item.SubItems.Add(IntToHex(AttrDef.CollationRule,2) + ' (hex)');
  Item.SubItems.Add(NTFSAttrDefFlagsToStr(AttrDef.Flags));
  Item.SubItems.Add(IntToStr(AttrDef.MinSize) + ' bytes');
  if AttrDef.MaxSize = -1 then
  Item.SubItems.Add('-')
  else
  Item.SubItems.Add(IntToStr(AttrDef.MaxSize) + ' bytes');
  M.ReadBuffer(AttrDef,SizeOf(TNTFSAttrDef));
  until (AttrDef.TypeOfAttr = 0) or (M.Size - M.Position < SizeOf(TNTFSAttrDef));
 M.Free;
 end
else
MessageDlg('No attribute definations found.',mtWarning,[mbOK],0);
MFT.Free;
end;

end.
