unit NTFSSearch;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ToolWin, ComCtrls, ImgList, StdCtrls, StrUtils, Menus, TemplateFormular,
  //VirtualListData,
  NTFS, Util;

type
  TNTFSSearchForm = class(TActionForm)
    StatusBar1: TStatusBar;
    View: TListView;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    StartButton: TToolButton;
    PauseButton: TToolButton;
    ToolButton3: TToolButton;
    SaveButton: TToolButton;
    ToolButton1: TToolButton;
    FindButton: TToolButton;
    FindNextButton: TToolButton;
    ImageList1: TImageList;
    InfoButton: TToolButton;
    SaveDlg: TSaveDialog;
    Filter: TEdit;
    PopupMenu1: TPopupMenu;
    MFTInfo1: TMenuItem;
    Save1: TMenuItem;
    CheckBox1: TCheckBox;

    procedure FormCreate(Sender: TObject);
  	procedure FormShow(Sender: TObject);
	  procedure FormClose(Sender: TObject; var Action: TCloseAction);

  	procedure StartButtonClick(Sender: TObject);
	  procedure PauseButtonClick(Sender: TObject);
  	procedure InfoButtonClick(Sender: TObject);
	  procedure SaveButtonClick(Sender: TObject);
  	procedure FindButtonClick(Sender: TObject);
	  procedure FindNextButtonClick(Sender: TObject);

  	procedure ViewClick(Sender: TObject);
	  procedure ViewDblClick(Sender: TObject);
  	procedure ViewColumnClick(Sender: TObject; Column: TListColumn);
	  procedure ViewCompare(Sender: TObject; Item1, Item2: TListItem; Data: Integer; var Compare: Integer);
    //procedure ViewCompare(Sender: TObject; Item1, Item2: TVirtualItem; Data: Integer; var Compare: Integer);
    procedure MFTInfo1Click(Sender: TObject);
  private
	{ Private declarations }
  public
		NTFS: TNTFS;
    partname: string;
		CurMFT: Cardinal;
		ToFind: string;
		procedure Search;
  private
    //FVirtualData:  TVirtualData;
  end;

const cWaitString='Searching, please wait...';

var
  NTFSSearchForm           : TNTFSSearchForm;
  ColumnToSortFound        : Integer;
  reverseorder             : Boolean;

implementation

uses Main, NTFSRecovery, NTFSMFT, DateUtils;

{$R *.dfm}

procedure TNTFSSearchForm.StartButtonClick(Sender: TObject);
begin
  if StartButton.Caption='&Start' then
  begin
    bStop:=false;
    bPaused:=False;
    StartButton.Caption:='&Stop';
    PauseButton.Enabled := true;
    //FVirtualData.BeginUpdate;
    //FVirtualData.Clear;
    //FVirtualData.EndUpdate;
    View.Items.BeginUpdate;
    View.Items.Clear;
    View.Items.EndUpdate;
    Search;
  end else begin
    bStop:=true;
    CurMFT := 0;
  end;
end;

procedure TNTFSSearchForm.FormCreate(Sender: TObject);
begin
  inherited;
  //FVirtualData:=TVirtualData.Create(View);
end;

procedure TNTFSSearchForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited FormClose(Sender,Action);
  if Assigned(ntfs) then
  ntfs.Free;
  //FVirtualData.Free;
end;

procedure TNTFSSearchForm.Search;
var Buffer         : TMemoryStream;
    FileRecHdr     : TNTFSFileRecordHeader;
    AttribHdr      : TNTFSStandardAttributeHeader;
    AttribHdrRes   : TNTFSStandardAttributeHeader_Resident;
    AttribHdrNonRes: TNTFSStandardAttributeHeader_NonResident;
    InfoAttr       : TNTFSStandardInfoAttribute;
    AttribName       : TNTFSFileNameAttribute;

    //PFileRecHdr      : PNTFSFileRecordHeader;
    //PAttribHdr       : PNTFSStandardAttributeHeader;
    PAttribHdrRes    : PNTFSStandardAttributeHeader_Resident;
    PAttribHdrNonRes : PNTFSStandardAttributeHeader_NonResident;
    PInfoAttr        : PNTFSStandardInfoAttribute;
    PAttribName      : PNTFSFileNameAttribute;

    MFTentry1, MFTentry2: TMFTEntry;
    ext              : string;
    origPath         : string;
    FileName         : WideString;
    LastAddr         : Int64;
    FileSize         : Int64;
    mftno2, lastcount: cardinal;
    aDir             :Boolean;
    Win32NameFound   : boolean;
    i, lastpercent   : Integer;

    Item           : TListItem;
    //Item             : TVirtualItem;
begin
	StatusBar1.Panels[0].Text := cWaitString;
  lastcount:=0;
  lastpercent:=0;

  //CurMFT:=1000000;

   if CurMFT=950337 then
   begin
     CurMFT:=CurMFT;
   end;
   if CurMFT=1000671 then
   begin
     CurMFT:=CurMFT;
   end;
  (**-) // debug
  for i := 0 to 10000 do
  begin
    MFTentry1 := NTFS.ReadMFTEntry(i);
    MFTentry1.free;
  end;
  (**)

  (**)
  //FVirtualData.BeginUpdate;
  View.SortType:=stNone;
  View.Items.BeginUpdate;
	repeat

     // show progress
     if trunc(CurMFT/NTFS.MaxMFT*100)>lastpercent then
     begin
         //StatusBar1.Panels[1].Text := IntToStr(CurMFT) + ' of ' + inttostr(NTFS.MaxMFT);
         lastpercent:=trunc(CurMFT/NTFS.MaxMFT*100);
         StatusBar1.Panels[1].Text := IntToStr(lastpercent)+'% - '+inttostr(View.Items.Count)+' found';
         StatusBar1.Refresh;
         View.Items.EndUpdate;
         //FVirtualData.EndUpdate;
         if (lastcount<>View.Items.count) then
         View.Invalidate; // Refresh;
         lastcount:=View.items.count;
         Application.ProcessMessages;
         View.Items.BeginUpdate;
         //FVirtualData.BeginUpdate;
         if bStop then break;
     end;

		 // ReadMFT data will now take care of parsing MFT fragments
		 Buffer := NTFS.ReadMFTData(CurMFT);
		 //Buffer := NTFS.ReadMFTDataAPI(CurMFT);
     if Buffer<>nil then
     begin
		 	 Buffer.ReadBuffer(FileRecHdr,SizeOf(FileRecHdr));

             // read some - the pointer way
             //PFileRecHdr:=Buffer.Memory;

		 	 if (FileRecHdr.FileID = 'FILE') and (not (fInUse in FileRecHdr.Flags)) then
		 	 //if (FileRecHdr.FileID = 'FILE') and (FileRecHdr.Flags<>'0x0000') then
		 	 //if (FileRecHdr.FileID = 'FILE') and (FileRecHdr.Flags<>0) then
		 	 begin
		 	   FileName := '';
		 	   FileSize := 0;
		 	   Win32NameFound := False;
		 	   Buffer.Position := FileRecHdr.OffsetToFirstAttr;
		 	   LastAddr := Buffer.Position;
		 	   Buffer.ReadBuffer(AttribHdr,SizeOf(AttribHdr));
         // go through all attributes and find what were looking for
	 	     while (AttribHdr.AttributeType <> $FFFFFFFF)
	 	       and (AttribHdr.AttributeType <> 1145127234) do // BAAD
         begin

		 	       if AttribHdr.AttributeType = NTFS_AttribID_File_Name then
		 	       begin // FileName
		 	           Buffer.ReadBuffer(AttribHdrRes,SizeOf(AttribHdrRes));
		 	           Buffer.ReadBuffer(AttribName,SizeOf(AttribName));
		 	           SetLength(FileName,AttribName.FileNameLength);
		 	           Buffer.Read(FileName[1],AttribName.FileNameLength * 2);
		 	           Win32NameFound := (AttribName.FileNamespace = npWin32) or (AttribName.FileNamespace = npDosAndWin32);

                 if CheckBox1.Checked then
                 begin
                   mftno2 := (AttribName.RefToParentDir and $FFFFFFFFFF);
                   if (mftno2 > 0) and (mftno2 <> 0) and (mftno2 <> 5) and (mftno2 <> CurMFT)
                     and (mftno2 < NTFS.MaxMFT)
                   then
                      origPath := NTFS.GetReferencedDir(mftno2, '',aDir);
                 end;

		 	           if Win32NameFound and (FileSize > 0) then Break;
		 	       end;

		 	       if AttribHdr.AttributeType = NTFS_AttribID_Data then
             begin // DATA
		 	           if AttribHdr.NonResident then
  						 	 begin
                     Buffer.ReadBuffer(AttribHdrNonRes,SizeOf(AttribHdrNonRes));
                     FileSize := AttribHdrNonRes.RealSize and $FFFFFFFF;
                 end else begin
                     Buffer.ReadBuffer(AttribHdrRes,SizeOf(AttribHdrRes));
                     FileSize := AttribHdrRes.AttributeLength;
                 end;
		 	           if Win32NameFound then Break;
		 	       end;

             if AttribHdr.AttributeType = NTFS_AttribID_Standard_Information then
               Buffer.ReadBuffer(InfoAttr,SizeOf(InfoAttr));

             if (AttribHdr.Size + LastAddr >= buffer.Size) or
                (AttribHdr.Size=0)
             then
               break;

		 	       Buffer.Position := LastAddr + Int64(AttribHdr.Size);
		 	       LastAddr := Buffer.Position; // remember
		 	       if Buffer.Size - Buffer.Position < SizeOf(AttribHdr) then Break;
		 	       Buffer.ReadBuffer(AttribHdr,SizeOf(AttribHdr));

         end; // while attributes


		 	   if (Pos(UpperCase(Filter.Text), UpperCase(FileName)) <> 0) or
		 	       (FileName = '') or (Filter.Text='') or (Filter.Text='*.*') or
		 	       (Filter.Text='*') then
         begin
             if (FileSize>0) then
             begin
                 if FileName = '' then FileName := '(no name)';


                 Item := View.Items.Add;
                 //Item.Data := Pointer(CurMFT);
                 Item.Caption := FileName; //ExtractFilename(FileName);
                 if fDir in FileRecHdr.Flags then
                 //if FileRecHdr.Flags=$0003 then
                   Item.ImageIndex := 1;

                 ext:=ExtractFileExt(FileName);
                 Item.SubItems.Add(RightStr(ext, Length(ext)-1));
                 Item.SubItems.Add(origPath);
                 Item.SubItems.Add(IntToStr(FileSize));

                 Item.SubItems.Add(NTFSTimeToStr(AttribName.TimeLastModified));
                 Item.SubItems.Add(NTFSTimeToStr(AttribName.TimeLastAccess));
                 Item.SubItems.Add(NTFSTimeToStr(AttribName.TimeMTFAltr));

                 Item.SubItems.Add(NTFSTimeToStr(AttribName.TimeCreated));
                 Item.SubItems.Add(inttostr(CurMFT));

                 if (View.Items.count mod 200 = 0) then
                 begin
                     lastpercent:=trunc(CurMFT/NTFS.MaxMFT*100);
                     StatusBar1.Panels[1].Text := IntToStr(lastpercent)+'% - '+inttostr(View.Items.Count)+' found';
                     StatusBar1.Refresh;
                     View.Items.EndUpdate;
                     //FVirtualData.EndUpdate;
                     if (lastcount<>View.Items.count) then
                     View.Invalidate; // Refresh;
                     lastcount:=View.items.count;
                     Application.ProcessMessages;
                     View.Items.BeginUpdate;
                     //FVirtualData.BeginUpdate;
                 end;
             end;
             if bStop then break;
		 	   end;
		 	 end;
		 	 Buffer.Free;
     end;
		 Inc(CurMFT);
	until (CurMFT >= NTFS.MaxMFT) or bstop or bPaused;

  View.Items.EndUpdate;
  //FVirtualData.EndUpdate;
  View.SortType:=stBoth;
	View.Refresh;
	Sleep(5);
	Application.ProcessMessages;
	if not bClosing then
  begin
    StartButton.Caption:='&Start';
		if CurMFT+1 >= NTFS.MaxMFT then
		begin
			CurMFT:=0;
			StatusBar1.Panels[0].Text := 'Search complete (' + IntToStr(View.Items.Count) + ' found)';
			PauseButton.Enabled := False;
			StartButton.Enabled := True;
		end else begin
			StatusBar1.Panels[0].Text := 'Search aborted (' + IntToStr(View.Items.Count) + ' found)';
			PauseButton.Enabled := True;
			StartButton.Enabled := True;
		end;
		StatusBar1.Panels[1].Text:='';
  end;
end;

procedure TNTFSSearchForm.PauseButtonClick(Sender: TObject);
begin
if not bPaused then
 begin
 bPaused := True;
 PauseButton.Down := True;
 PauseButton.Caption := 'Resume';
 PauseButton.Enabled := True;
 StatusBar1.Panels[0].Text := 'Paused, click "Resume" to continue';
 end
else
 begin
 StatusBar1.Panels[0].Text := cWaitString;
 bPaused := False;
 PauseButton.Caption := 'Pause';
 PauseButton.Down := False;
 Search;
 end;
end;

procedure TNTFSSearchForm.FindButtonClick(Sender: TObject);
var S: string;
    I: Integer;
begin
if InputQuery('Find','Find filename containing:',S) then
 begin
 ToFind := LowerCase(S);
 for I := 0 to View.Items.Count - 1 do
  begin
  if boolean(Pos(ToFind,LowerCase(View.Items[I].Caption))) then
   begin
   View.Selected := View.Items[I];
   View.Selected.MakeVisible(False);
   MessageBeep(MB_ICONINFORMATION);
   Exit;
   end;
  end;
 MessageDlg('Not found.',mtInformation,[mbOK],0);
 end;
end;

procedure TNTFSSearchForm.FindNextButtonClick(Sender: TObject);
var I: Integer;
begin
if (ToFind <> '') and (View.Items.Count > 1) and (View.ItemIndex > -1) then
 begin
 for I := View.Selected.Index + 1 to View.Items.Count - 1 do
  begin
  if boolean(Pos(ToFind,LowerCase(View.Items[I].Caption))) then
   begin
   View.Selected := View.Items[I];
   View.Selected.MakeVisible(False);
   MessageBeep(MB_ICONINFORMATION);
   Exit;
   end;
  end;
 MessageDlg('Not found.',mtInformation,[mbOK],0);
 end
else
 begin
 FindButton.Click;
 end;
end;

procedure TNTFSSearchForm.ViewClick(Sender: TObject);
begin
  SaveButton.Enabled := View.ItemIndex > -1;
  InfoButton.Enabled    := View.ItemIndex > -1;
end;

procedure TNTFSSearchForm.SaveButtonClick(Sender: TObject);
var
		MFT: Cardinal;
		MFTEnt: TMFTEntry;
		F: TMemoryStream;
		I, J, k, r, x: Integer;
		Path: string;
		fname: string;
		parent:cardinal;
begin

	(*
  with TNTFSRecoverForm.Create(Application) do
	begin
  	NTFS := TNTFS.Create(Self.NTFS.PartInfo);
	  MFTNum := Cardinal(View.Selected.Data);
    Show;
	end;
  *)

	SaveDlg.FileName := '[ --- name will be ignored --- ]';
	if SaveDlg.Execute then
			Path := ExtractFilePath(SaveDlg.FileName)
	else exit;
		k:=0; r:=0; x:=0;

	for J:=0 to View.Items.Count-1 Do
	if View.Items[J].Selected then
  begin
		 StatusBar1.Panels[0].Text := 'Recovering file ' + IntToStr(r)+'/'+IntToStr(View.SelCount+x-1);
		 StatusBar1.Refresh;
		 Inc(x);
		 MFT := Cardinal(View.Items[J].Data);
		 MFTEnt := NTFS.ReadMFTEntry(MFT);
		 I := MFTEnt.IndexOfAttrib(NTFS_AttribID_Data);
		 if I > -1 then begin
		  fName := MFTEnt.GetFileName(parent);
		  if fName = '' then begin
		  	Inc(k);
			  fName :=  Path + 'noname'+IntToStr(k);
		  end else
			  fName :=  Path + fName;

		   (*
		   while FileExists(fname) do begin
			  i := Length(fname)-1;
			  while not Isnumeric(fname[i]) do Dec(i);
			  j := i;
			  while Isnumeric(fname[j]) do Dec(j);
			  Val(Copy(fname, j+1, i-j), num, dum);
			  fname := Copy(fname, 1, j) + IntToStr(num+1) + Copy(fname, j+i-j+1, Length(fname)-1);
		   end;
		   *)

		  try

		   if MFTEnt.Attrib[I].Hdr.NonResident then begin
		    F := NTFS.ReadRunListData(MFTEnt.Attrib[I], fName, MFTEnt.InfoStdHdr);
		    // HdrNonRes.RealSize in sometimes way too big here too...
		    // initializedsize seems to have sensible values
		    //F.SetSize(MFTEnt.Attrib[I].HdrNonResident.StreamInitializedSize);
		    //F.Position := 0;
		   end else begin
		    MFTEnt.Attrib[I].Data.Position := MFTEnt.Attrib[I].HdrResident.AttributeOffset;
		    F := TMemoryStream.Create;
		    F.CopyFrom(MFTEnt.Attrib[I].Data, MFTEnt.Attrib[I].HdrResident.AttributeLength);
		    F.Position := 0;
		    F.SaveToFile(fName);
		    F.Free;
		   end;

		   //F := NTFS.ReadFile(MFTEnt.Attrib[I]);
		   Inc(r);

		   {
		   While i<MFTEnt.Attrib[I].HdrNonResident.StreamInitializedSize do begin
		       //F.ReadBuffer(buff, 1024);
		       //F.Sav
		   end;
		   }

		   View.Items[J].Selected:=False;
		   View.Items[J].Caption := '[recovered]-'+View.Items[J].Caption;
		   View.Refresh;
		  except
		   on E: Exception do MessageDlg('File recovery failed. ' + E.Message,mtError,[mbOK],0);
		  end;

 		end else
		  MessageDlg('File is empty: ' + View.Items[J].Caption, mtInformation, [mbOk], 0);
		 MFTEnt.Free;
		end; //if selected

		StatusBar1.Panels[0].Text := IntToStr(r)+'/'+IntToStr(x)+' files Recovered.';
end;

procedure TNTFSSearchForm.FormShow(Sender: TObject);
begin
  Application.ProcessMessages;
  ClearMessageBuffers;
  ResetStatus;
  reverseorder:= false;
  StatusBar1.Panels[0].Text:=inttostr(NTFS.MaxMFT)+' entries';
end;

procedure TNTFSSearchForm.ViewDblClick(Sender: TObject);
begin
  if View.ItemIndex > -1 then
    InfoButton.Click;
end;

procedure TNTFSSearchForm.InfoButtonClick(Sender: TObject);
var MFT: TMFTEntry;
    I: Integer;
begin
  MFT := NTFS.ReadMFTEntry(Integer(View.Selected.Data));
  I := MFT.IndexOfAttrib(NTFS_AttribID_File_Name);
  MFT.Free;
  if I > 0 then
  begin
  with TNTFSMFTForm.Create(Application) do
    begin
    NTFS := TNTFS.Create(Self.NTFS.PartInfo);
    CurMFT := Integer(View.Selected.Data);
    UpdateNew;
    Tree.Selected := Tree.Items[0].Item[I].GetLastChild;
    end;
  end;
end;

function CompareNumbers(s1:string; s2: string): integer;
var n1, n2 : Int64;
begin
  if s1='-' then begin if reverseorder then result:=1 else  result:=-1; exit; end;
  if s2='-' then begin if reverseorder then result:=1 else  result:=-1; exit; end;
	result:=0;
	n1:=StrToInt64Def(s1,0); n2:=StrToInt64Def(s2,0);
	if n1<n2 then result:=1
	else if n1>n2 then result:=-1;
end;

procedure TNTFSSearchForm.ViewCompare(Sender: TObject; Item1, Item2: TListItem; Data: Integer; var Compare: Integer);
var ix   : Integer;
begin
  ix:=ColumnToSortFound-1;
  if (ix < 0) then
	  if not reverseorder then
    Compare :=  CompareStr(Item1.Caption,Item2.Caption)
    else
    Compare := -CompareStr(Item1.Caption,Item2.Caption)
  else begin
	  if (ix = 2) or (ix = 7) then
	  if not reverseorder then
	    Compare :=  CompareNumbers(Item1.SubItems[ix],Item2.SubItems[ix])
    else
	    Compare := -CompareNumbers(Item1.SubItems[ix],Item2.SubItems[ix])
    else
	    if not reverseorder then
  	    Compare :=  CompareStr(Item1.SubItems[ix],Item2.SubItems[ix])
	    else
	      Compare := -CompareStr(Item1.SubItems[ix],Item2.SubItems[ix])
  end;
end;

procedure TNTFSSearchForm.ViewColumnClick(Sender: TObject; Column: TListColumn);
begin
   if bClosing or bStop then exit;
   if (ColumnToSortFound=Column.Index) then reverseorder:= not reverseorder;
   ColumnToSortFound := Column.Index;
   (Sender as TCustomListView).AlphaSort;
end;

procedure TNTFSSearchForm.MFTInfo1Click(Sender: TObject);
var MFT: TMFTEntry;
    I: Integer;
begin
  MFT := NTFS.ReadMFTEntry(Integer(View.Selected.Data));
  I := MFT.IndexOfAttrib(NTFS_AttribID_File_Name);
  MFT.Free;
  if I > 0 then
  begin
    with TNTFSMFTForm.Create(Application) do
    begin
      NTFS := TNTFS.Create(Self.NTFS.PartInfo);
      CurMFT := Integer(View.Selected.Data);
      //Show;
      UpdateNew;
      Tree.Selected := Tree.Items[0].Item[I].GetLastChild;
    end;
  end;
end;

end.
